<?php 

// +------------------------------------------------------------------+
// |                                                                  |
// | Copyright 1999-Present Kryptronic, Inc. All rights reserved.     |
// |                                                                  |
// | This software is copyrighted, trademarked, developed and         |
// | licensed by Kryptronic, Inc. This software is distributed        |
// | under license.                                                   |
// |                                                                  |
// | View the license agreement for more information.  Installation   |
// | of this software package indicates acceptance of the license     |
// | agreement.                                                       |
// |                                                                  |
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | IF INSTRUCTED TO EDIT THE $main_path_force VARIABLE, EDIT THE    |
// | VALUE BETWEEN THE SINGLE QUOTES ON THE FOLLOWING LINE.           |
// +------------------------------------------------------------------+

$main_path_force   = '';

$perms_level_files  = '755';
$perms_level_dirs   = '755';
$perms_level_exec   = '755';
$perms_level_config = '640';

// +------------------------------------------------------------------+
// | DO NOT EDIT BELOW THIS LINE.                                     |
// +------------------------------------------------------------------+

// +--
// | Debugger Note:  If you would like to turn debugging on, once the
// | core is installed you can adjust the class $debug variable in
// | the file {PRIVATE}/core/CORE/CORE.php.  The following settings
// | apply:
// |
// | 0:         Debugging off (default)
// | 1:         File-based output (sent to {PRIVATE}/temp directory)
// | 2:         Browser-based output (sent to web browser)
// +--

// +--
// | The following parameters are to be left alone.  They represent
// | core directives that affect how this program operates when 
// | executed.  These parameters need to remain unchanged here but 
// | may require changes to run other core-based scripts via methods
// | like cron.
// |
// | app:       The 'app' parameter is generally left blank.  'app' is
// |            passed using URL parameters.
// |
// | namespace: The 'namespace' parameter is generally left blank.  
// |            'namespace' is passed using URL parameters.
// |
// | interface: The 'interface' parameter dictates the interface
// |            to be run by the core.
// | 
// |            Value FrontEnd:  Produces frontend interface
// |            Value BackEnd:   Produces backend (admin) interface
// |            Value Installer: Produces installer (admin without
// |                             login) interface
// |
// | output:    The 'output' parameter allows the caller script to
// |            run the core without any output being generated.
// |           
// |            Value 0:         No Output Produced
// |            Value 1:         Output standards compliant XHTML
// |
// | errhandle: The 'errhandle' parameter allows the caller script to
// |            specify whether errors should be triggered or returned
// |            in an array.
// |           
// |            Value 0:         Trigger error in core
// |            Value 1:         Return a COREerror object.
// +--

$interface = 'BackEnd';
$output    = 1;
$errhandle = 1;

// +--
// | Enter the importer script name if it has been changed.  We also
// | set the script up as a robot so cookies are not printed.
// +--

$importer_script = 'importer-v8-v9.php';
$importer_name   = 'ClickCartPro/EuropaCart 8';
$robot           = 'Kryptronic Importer: ' . $importer_name;

// +--
// | Set permissions level for executable files and 
// | dirs to the same level as this file.
// +--

$thisfile = __FILE__;

while (preg_match('/\\\\/',$thisfile)) {$thisfile = preg_replace('/\\\\/','/',$thisfile);}

while (preg_match('/\/\//',$thisfile)) {$thisfile = preg_replace('/\/\//','/',$thisfile);}

$thisfile = preg_replace('/\/$/','',$thisfile);

$thisfile_perms = @substr(@decoct(@fileperms($thisfile)),3);

if ((!(empty($thisfile_perms))) && ($thisfile_perms == 755)) {

     $perms_level_exec = $thisfile_perms;

} // End of if statement.


// +--
// | Main program loader.  This object call creates an instance
// | of the COREmain class.  When the exec() function runs, the
// | program runs and produces output.  We exit() afterwards.
// +--

$coremain = new COREmain;

$coremain->exec(array('core.main_path_force'    => $main_path_force,
                      'core.interface'          => $interface,
                      'core.output'             => $output,
                      'core.errhandle'          => $errhandle,
                      'core.perms_level_files'  => $perms_level_files,
                      'core.perms_level_dirs'   => $perms_level_dirs,
                      'core.perms_level_exec'   => $perms_level_exec,
                      'core.perms_level_config' => $perms_level_config,
                      'importer.script_name'    => $importer_script,
                      'importer.name'           => $importer_name,
                      'core.robot'              => $robot));

// +--
// | Exit() is called from within the core during it's shutdown
// | function, however it's good practice to call it here as well
// | to handle garbage collection.
// +--

exit();

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | COREmain Core Class                                              |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Class Definition                                                 |
// +------------------------------------------------------------------+

class COREmain {

// +--
// | This class is used to verify the PHP environment we're running
// | in, load and execute the CORE class and provide error handling
// | outside of the scope of the main core class.
// +--

// +------------------------------------------------------------------+
// | Class Variables                                                  |
// +------------------------------------------------------------------+

var $class   = 'COREmain';
var $version = '9.3.0';
var $cerror;

// +------------------------------------------------------------------+
// | Constructor Function                                             |
// +------------------------------------------------------------------+

function __construct () {

// +--
// | This is the constructor function.  This function starts up the
// | class.  Any pre-load variable assignments go here.
// +--

// +--
// | Return object.
// +--

return $this;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec                                                   |
// +------------------------------------------------------------------+

function exec ($input = array()) {

// +--
// | This routine is run to run the internals of the class.  Main class
// | logic is contained in this function.
// +--

// +--
// | Set our timezone to avoid PHP5 notices about the timezone
// | not being set.
// +--

if ((function_exists('date_default_timezone_get')) && (!(ini_get('date.timezone')))) {

     $timezone = @date_default_timezone_get();

     if (function_exists('date_default_timezone_set')) {

          @date_default_timezone_set($timezone);

     } // End of if statement.

} // End of if statement.

// +--
// | Globalize our input array.
// +--

if (!(empty($input))) {

     foreach ($input as $key => $value) {$this->globals($key,$value);}

} // End of if statement.

// +--
// | Set error handling up to output errors to the browser.  We handle
// | all errors except for E_NOTICE and E_STRICT errors.
// +--

ini_set('display_errors','1');

error_reporting(E_ALL & ~E_STRICT & ~E_NOTICE);

set_exception_handler(array($this,'exception_display'));
set_error_handler(array($this,'error_display'));

// +--
// | Determine the directory from where we're running this program.
// +--

$path = $this->globals('core.main_path_force');

if ((!(empty($path))) && (@file_exists($path))) {

     $path = $this->globals('core.main_path_force');

} elseif (@file_exists(dirname(__FILE__))) {

     $path = dirname(__FILE__);

} elseif (@file_exists(getcwd())) {

     $path = getcwd();

} elseif (@file_exists(dirname($_SERVER['PATH_TRANSLATED']))) {

     $path = dirname($_SERVER['PATH_TRANSLATED']);

} elseif (@file_exists(dirname($_SERVER['SCRIPT_FILENAME']))) {

     $path = dirname($_SERVER['SCRIPT_FILENAME']);

} else {

     $errstr = "

     <p>This script could not determine the directory from which it is 
     being executed.  You need to edit the scripts 'index.php', 'admin.php' 
     and 'installer.php' and enter a value for the \$main_path_force 
     variable at the top of those scripts. Follow the instructions in each of 
     those scripts for more information.</p>

     <p>If you have already edited the \$main_path_force variable and are 
     seeing this message again, the value you used for that variable 
     appears to be incorrect.  Please try again.</p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | Format our working directory we've just determined and globalize it.
// +--

$path = $this->paths_convert($path);

$this->globals('core.main_path_force',$path);

// +--
// | Include our config.php in the public directory.  Globalize the 
// | config array.
// +--

if (@file_exists($this->globals('core.main_path_force') . '/config.php')) {

     include($this->globals('core.main_path_force') . '/config.php');

     foreach ($config as $key => $value) {$this->globals($key,$value);}

     unset($config);

} // End of if statement.

// +--
// | If the $config array key 'core.path_private' was not defined,
// | we had a problem and need to error out.
// +--

$pathpriv = $this->globals('core.path_private');

if (empty($pathpriv)) {

     $errstr = "

     <p>It appears you have not run the core 
     installer script.  You need to run the installer script before
     accessing this script.</p>

     <p><a href=\"installer.php\" title=\"Installer\">Click here to run
     the installer script.</a></p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | Our private config file will be included automatically
// | by the core when it loads up.
// |
// | Now that we have our public config file included,
// | we can include our main core file.
// +--

$privpath = $this->globals('core.path_private');

if (@file_exists($privpath . '/custom/core/CORE/CORE.php')) {

     include_once($privpath . '/custom/core/CORE/CORE.php');

} elseif (@file_exists($privpath . '/core/CORE/CORE.php')) {

     include_once($privpath . '/core/CORE/CORE.php');

// +--
// | If there is a problem finding the file, we error out.
// +--

} else {

     $errstr = "

     <p>This script could not locate the file 'CORE.php' in the
     directory:</p>

     <p>{$privpath}/core/CORE</p>

     <p>This could be the result of an incomplete installation.  The
     configuration files created by the installer appear to be complete, 
     however the installation of the codebase is incomplete.  This is a
     fatal error that cannot be resolved automatically.  Reinstall the
     software to continue.</p>

     <p><a href=\"installer.php\" title=\"Installer\">Click here to run
     the installer script.</a></p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | If we were able to include our main core file, we can run the core.
// | Above we set 'output' to '0' and 'errhandle' to '1' so the core will 
// | produce no output and not trigger errors internally.  There is no need 
// | to check for errors at this level.  
// |
// | Create the CORE object.
// +--

global $xglobal_cache;

$core = new CORE($xglobal_cache);

if ($core->IsError($core->cerror)) {

     trigger_error($core->cerror->GetMessage(),E_USER_ERROR);

} // End of if statement.

// +--
// | Run the importer.  We pass it's constructor a reference to our
// | CORE object.
// +--

$importer = new COREimporter($core);

if ($core->IsError($importer->cerror)) {

     trigger_error($importer->cerror->GetMessage(),E_USER_ERROR);

} // End of if statement.

$importer->exec();

// +--
// | Run core shutdown method.
// +--

$core->shutdown();

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: globals                                                |
// +------------------------------------------------------------------+

function globals ($name = '',$value = null,$default = null) {

// +--
// | This function maintains a global array of global variables for
// | use within the program.  Global variables can be set, changed and
// | obtained from this function.
// +--

global $xglobal_cache;

// +--
// | If the request contained a default identifier (passed as a true
// | value), we set a default value if the global doesn't exist.
// +--

if ((!(empty($name))) && (isset($value)) && (isset($default)) && (!(isset($xglobal_cache[$name])))) {

     $xglobal_cache[$name] = $value;

     return $value;

} // End of if statement.

// +--
// | Set requests have both a name and value passed
// | to this function.
// +--

if ((!(empty($name))) && (isset($value)) && (!(isset($default)))) {

     $xglobal_cache[$name] = $value;

     return $value;

} // End of if statement.

// +--
// | Get requests have only a global variable name
// | passed to this function.
// +--

if ((!(empty($name))) && (isset($xglobal_cache[$name]))) {

     return $xglobal_cache[$name];

} // End of if statement.

// +--
// | All other requests result in a null return value.
// +--

return null;

} // End of function.

// +------------------------------------------------------------------+
// | Function: paths_convert                                          |
// +------------------------------------------------------------------+

function paths_convert ($string) {

// +--
// | This function converts filesystem paths to unix-style and strips
// | any trailing slashes.
// +--

while (preg_match('/\\\\/',$string)) {$string = preg_replace('/\\\\/','/',$string);}

while (preg_match('/\/\//',$string)) {$string = preg_replace('/\/\//','/',$string);}

$string = preg_replace('/\/$/','',$string);

return $string;

} // End of function.

// +------------------------------------------------------------------+
// | Function: paths_strip                                            |
// +------------------------------------------------------------------+

function paths_strip ($string) {

// +--
// | This function strips full server paths from a given string for
// | security purposes.
// +--

$pathpub   = $this->globals('core.path_public');
$pathpriv  = $this->globals('core.path_private');
$pathforce = $this->globals('core.main_path_force');

$string = str_replace('\\','/',$string);

if (!(empty($pathforce))) {

     $find   = preg_quote($pathforce . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.
 
if (!(empty($pathpub))) {

     $find   = preg_quote($pathpub . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.

if (!(empty($pathpriv))) {

     $find   = preg_quote($pathpriv . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.

return $string;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exception_display                                      |
// +------------------------------------------------------------------+

function exception_display ($exception = '') {

// +--
// | This function is called via PHP when an uncaught exception is 
// | encountered.
// +--

if (empty($exception)) {return 1;}

return $this->error_display(E_USER_ERROR,$exception->getMessage(),$exception->getFile(),$exception->getLine());

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_display                                          |
// +------------------------------------------------------------------+

function error_display ($errno = '',$errstr = '',$errfile = '',$errline = '') {

// +--
// | This function is called via PHP when an error is encountered.
// | Scripts pass errors through this function via PHP's trigger_error
// | function using:
// |
// | trigger_error('some_error_message',E_USER_ERROR);
// | 
// | PHP also passes errors through this function without script
// | intervention.
// +--

// +--
// | Return true if this is an error we don't care about.
// +--

$recoverable = 0;

if     (error_reporting() == 0)                                          {$recoverable++;}
elseif ((defined('E_STRICT')) && ($errno == E_STRICT))                   {$recoverable++;}
elseif ((defined('E_NOTICE')) && ($errno == E_NOTICE))                   {$recoverable++;}
elseif ((defined('E_USER_NOTICE')) && ($errno == E_USER_NOTICE))         {$recoverable++;}
elseif ((defined('E_DEPRECATED')) && ($errno == E_DEPRECATED))           {$recoverable++;}
elseif ((defined('E_USER_DEPRECATED')) && ($errno == E_USER_DEPRECATED)) {$recoverable++;}
elseif ((defined('E_WARNING')) && ($errno == E_WARNING))                 {$recoverable++;}

if (!(empty($recoverable))) {return 1;}

// +--
// | If we are currently buffering output, destroy the buffer
// | and reset buffer status.
// +--

if ($this->globals('installer.buffer_status')) {

     @ob_end_clean();

     $this->globals('installer.buffer_status',0);

} // End of if statement.

// +--
// | Modify our $errfile if it is non-blank.  We want to remove
// | full paths from error messages to increase security.
// +--

if ($errfile) {$errfile = $this->paths_strip($errfile);}

// +--
// | Modify our $errstr if it is non-blank.  We want to add <p>
// | tags if they're not there.
// +--

if (($errstr) && (!(preg_match('/<p>/',$errstr)))) {

     $errstr = '<p>' . $errstr . '</p>';

} // End of if statement.

// +--
// | Print output header.
// +--

print $this->error_div_header();

// +--
// | Print output content.
// +--

if ($errstr) {print $this->error_div_content($errstr);}

// +--
// | Print output info.
// +--

if ($errno && $errline && $errfile) {print $this->error_div_info($errno,$errline,$errfile);}

// +--
// | Print output footer.
// +--

print $this->error_div_footer();

// +--
// | This was a fatal error so we exit.
// +--

exit();

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_header                                       |
// +------------------------------------------------------------------+

function error_div_header () {

// +--
// | This function prints the error header.
// +--

$xhtml = <<<ENDOFTEXT

<!DOCTYPE html>

<html lang="en">

<head>

<meta name="viewport" content="width=device-width, initial-scale=1" />

<link rel="preconnect" href="https://fonts.googleapis.com" />
<link rel="preconnect" href="https://fonts.gstatic.com" crossorigin />
<link href="https://fonts.googleapis.com/css2?family=Roboto:wght@400;700&display=swap" rel="stylesheet" />

<style media="all">
body {color: #000000; background-color: #F4F4F4; font-weight: normal; text-align: left; margin: 0; padding: 0; font-family: 'Roboto', Arial, Helvetica, sans-serif; font-size: 16px;}
a {color: #0089DA; text-decoration: none;}
a:hover {text-decoration: underline;}
#kcontentwrap {margin: 2em auto 2em auto; width: 50em; max-width: 90%; padding: 1em; background-color: #FFFFFF; border: 1px solid #DEDEDE; padding: 2em;}
#kinfo {font-size: .9em; font-style: italic; margin-top: 2em;}
.khidden {display: none;}
.kwrap {line-height: 1.5;}
.kwrap h1 {font-size: 2em; font-weight: normal; margin: 0 0 .5em 0; color: #0089DA;}
.kwrap p {padding: 0; margin: 0 0 .75em 0;}
.kwrap p:last-child {margin-bottom: 0;}
</style>

<title>Script Execution Error</title>

</head>

<body>

<div id="kcontentwrap" class="kwrap">

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_content                                      |
// +------------------------------------------------------------------+

function error_div_content ($errstr = '') {

// +--
// | This function prints the error contet.
// +--

$xhtml = <<<ENDOFTEXT

<h1>Script Execution Error</h1>

{$errstr}

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_info                                         |
// +------------------------------------------------------------------+

function error_div_info ($errno = '',$errline = '',$errfile = '') {

// +--
// | This function prints the error info.
// +--

$xhtml = <<<ENDOFTEXT

<div id="kinfo">File: {$errfile} Line: {$errline} Error Number: {$errno}</div>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_footer                                       |
// +------------------------------------------------------------------+

function error_div_footer () {

// +--
// | This function prints the error footer.
// +--

$xhtml = <<<ENDOFTEXT

</div>

</body>

</html>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | End of Class                                                     |
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Core Class                                              |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Class Definition: COREimporter                                   |
// +------------------------------------------------------------------+

class COREimporter {

// +--
// | This class handles data imports into the core  This script is to 
// | be considered standalone software and it's architecture and 
// | methodology are not indicative of the core core codebase.  
// | Do not use code in this COREimporter class as a basis for core
// | core or component code.
// +--

// +------------------------------------------------------------------+
// | Class Variables                                                  |
// +------------------------------------------------------------------+

var $class   = 'COREimporter';
var $version = '9.3.0';
var $cerror;

var $dbrows_atonce = 100;

var $CORE;
var $CORE_Display;
var $CORE_DB;
var $CORE_DBX;
var $CORE_Crypt;
var $CORE_File;
var $CORE_Remote;
var $CORE_XML;

// +------------------------------------------------------------------+
// | Constructor Function                                             |
// +------------------------------------------------------------------+

function __construct ($core_object = '') {

// +--
// | This is the constructor function.  This function starts up the
// | class.  Any pre-load variable assignments go here.
// +--

// +--
// | Define our CORE object.
// +--

$this->CORE =& $core_object;

// +--
// | Quick object load: CORE_Display
// +--

$this->CORE_Display =& $this->CORE->quick_object('CORE_Display','core');

if ($this->CORE->IsError($this->CORE_Display)) {$this->cerror = $this->CORE_Display; return;}

// +--
// | Quick object load: CORE_DB
// +--

$this->CORE_DB =& $this->CORE->quick_object('CORE_DB','core','CORE_DB_1');

if ($this->CORE->IsError($this->CORE_DB)) {$this->cerror = $this->CORE_DB; return;}

// +--
// | Quick object load: CORE_Crypt
// +--

$this->CORE_Crypt =& $this->CORE->quick_object('CORE_Crypt','core');

if ($this->CORE->IsError($this->CORE_Crypt)) {$this->cerror = $this->CORE_Crypt; return;}

// +--
// | Quick object load: CORE_File
// +--

$this->CORE_File =& $this->CORE->quick_object('CORE_File','core');

if ($this->CORE->IsError($this->CORE_File)) {$this->cerror = $this->CORE_File; return;}

// +--
// | Quick object load: CORE_Remote
// +--

$this->CORE_Remote =& $this->CORE->quick_object('CORE_Remote','core');

if ($this->CORE->IsError($this->CORE_Remote)) {$this->cerror = $this->CORE_Remote; return;}

// +--
// | Quick object load: CORE_XML
// +--

$this->CORE_XML =& $this->CORE->quick_object('CORE_XML','core');

if ($this->CORE->IsError($this->CORE_XML)) {$this->cerror = $this->CORE_XML; return;}

// +--
// | Load the PEAR File_Find class.
// +--

$result = $this->CORE->load_pear('File_Find');

if ($this->CORE->IsError($result)) {$this->cerror = $result; return;}

// +--
// | Return object.
// +--

return $this;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Wrapper                                                 |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: exec                                                   |
// +------------------------------------------------------------------+

function exec () {

// +--
// | This function runs the internals of the importer program.
// +--

// +--
// | Define some important variables.
// +--

$this->CORE->globals('importer.numsteps','20');

// +--
// | Start buffering output.
// +--

if (!($this->CORE->globals('importer.buffer_status'))) {

     @ob_start();

     $this->CORE->globals('importer.buffer_status',1);

} // End of if statement.

// +--
// | Start processing.
// +--

$result = $this->exec_do();

if ($this->CORE->IsError($result)) {

     trigger_error($result->GetMessage(),E_USER_ERROR);

} // End of if statement.

// +--
// | Finish buffering output.
// +--

if ($this->CORE->globals('importer.buffer_status')) {

     $buffered_output = @ob_get_contents();

     @ob_end_clean();

     $this->CORE->globals('importer.buffered_output',$buffered_output);

     $this->CORE->globals('importer.buffer_status',0);

} // End of if statement.

// +--
// | Kill the buffering in the core and set our display status to
// | false.
// +--

$this->CORE_Display->buffer('CLEAN');

$this->CORE->globals('core.output',0);

// +--
// | Print the display.
// +--

$this->disp();

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec_do                                                |
// +------------------------------------------------------------------+

function exec_do () {

// +--
// | This function processes the main logic of the importer.
// +--

// +--
// | Define the step we're on.
// +--

$step = $this->CORE->globals('core_cgi.step');

if (!($step)) {$step = 'Intro';}

// +--
// | Get password info from form input and present the right 
// | interface.
// +--

$password = $this->CORE->globals('core.password');

if (!(empty($password))) {

     $import_password = $this->CORE->globals('core_cgi.import_password');

     if (!($import_password)) {

          $step = 'Password';

     } elseif (md5($import_password) != $password) {

          $message = "The password you entered is incorrect.  Please try again.";
          $step    = 'Password';

          $this->disp_message($message,'ERROR');

     } // End of if statement.

} elseif ($step != 'IntroP') {

     $step = 'Intro';

} // End of if statement.

// +--
// | Check the status of our license agreement acceptance.
// +--

$license_agree = $this->CORE->globals('core_cgi.license_agree');

if (empty($license_agree)) {

          if ($step != 'Password' && $step != 'Intro') {

          $message = "You did not agree to the terms and conditions in the EULA.  
                      You must agree to these terms and conditions to continue.";

          if ($step == 'IntroP') {$step = 'Intro';}

          else {$step = 'Password';}

          $this->disp_message($message,'ERROR');

     } // End of if statement.

} // End of if statement.

// +--
// | Execute our step.
// +--

$result = $this->exec_step($step);

if ($this->CORE->IsError($result)) {return $result;}

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec_step                                              |
// +------------------------------------------------------------------+

function exec_step ($step = 'Default') {

// +--
// | This function executes importer steps.
// +--

// +--
// | Use the step to figure out what we need to be doing.  If the
// | step is blank, we default to step I.  A list of the steps is
// | below:
// |
// | Step Number  Action          
// | -----------  -------------------
// | Default      Default Invalid Info Screen
// | Password     Password Collection
// | Location     Installation Location
// | LocationP    Installation Location - Process
// | Settings     Software Settings
// | SettingsP    Software Settings - Process
// | Media        Media Files
// | MediaP       Media Files - Process
// | CustAcct     Customer Accounts
// | CustAcctP    Customer Accounts - Process
// | Affiliates   Affiliate Payments 
// | AffiliatesP  Affiliate Payments - Process
// | Maillist     Email List Subscribers
// | MaillistP    Email List Subscribers - Process
// | Category     Categories
// | CategoryP    Categories - Process
// | ProdOpt      Product Options
// | ProdOptP     Product Options - Process
// | Product      Product Offers
// | ProductP     Product Offers - Process
// | Orders       Orders
// | OrdersP      Orders - Process
// | Discounts    Discount Codes
// | DiscountsP   Discount Codes - Process
// | HtmlPage     HTML Pages (User Defined)
// | HtmlPageP    HTML Pages (User Defined) - Process
// | DynForm      Dynamic Forms
// | DynFormP     Dynamic Forms - Process
// | DynFormFld   Dynamic Form Fields
// | DynFormFldP  Dynamic Form Fields - Process
// | Banners      Banners
// | BannersP     Banners - Process
// | Reviews      Reviews
// | ReviewsP     Reviews - Process
// | CustSale     Custom Sale Scripts
// | CustSaleP    Custom Sale Scripts - Process
// | CustShip     Custom Shipping Scripts
// | CustShipP    Custom Shipping Scripts - Process
// | CustSurch    Custom Surcharge Scripts
// | CustSurchP   Custom Surcharge Scripts - Process
// | Final        Final Confirm Display
// +--

switch ($step) {

     case "Password":
          $result = $this->step_Password();
          break;

     case "Location":
          $result = $this->step_Location();
          break;

     case "LocationP":
          $result = $this->step_LocationP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Location();
          }
          break;

     case "Settings":
          $result = $this->step_Settings();
          break;

     case "SettingsP":
          $result = $this->step_SettingsP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Settings();
          }
          break;

     case "Media":
          $result = $this->step_Media();
          break;

     case "MediaP":
          $result = $this->step_MediaP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Media();
          }
          break;

     case "CustAcct":
          $result = $this->step_CustAcct();
          break;

     case "CustAcctP":
          $result = $this->step_CustAcctP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_CustAcct();
          }
          break;

     case "Affiliates":
          $result = $this->step_Affiliates();
          break;

     case "AffiliatesP":
          $result = $this->step_AffiliatesP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Affiliates();
          }
          break;

     case "Maillist":
          $result = $this->step_Maillist();
          break;

     case "MaillistP":
          $result = $this->step_MaillistP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Maillist();
          }
          break;

     case "Category":
          $result = $this->step_Category();
          break;

     case "CategoryP":
          $result = $this->step_CategoryP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Category();
          }
          break;

     case "ProdOpt":
          $result = $this->step_ProdOpt();
          break;

     case "ProdOptP":
          $result = $this->step_ProdOptP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_ProdOpt();
          }
          break;

     case "Product":
          $result = $this->step_Product();
          break;

     case "ProductP":
          $result = $this->step_ProductP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Product();
          }
          break;

     case "Orders":
          $result = $this->step_Orders();
          break;

     case "OrdersP":
          $result = $this->step_OrdersP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Orders();
          }
          break;

     case "Discounts":
          $result = $this->step_Discounts();
          break;

     case "DiscountsP":
          $result = $this->step_DiscountsP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Discounts();
          }
          break;

     case "HtmlPage":
          $result = $this->step_HtmlPage();
          break;

     case "HtmlPageP":
          $result = $this->step_HtmlPageP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_HtmlPage();
          }
          break;

     case "DynForm":
          $result = $this->step_DynForm();
          break;

     case "DynFormP":
          $result = $this->step_DynFormP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_DynForm();
          }
          break;

     case "DynFormFld":
          $result = $this->step_DynFormFld();
          break;

     case "DynFormFldP":
          $result = $this->step_DynFormFldP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_DynFormFld();
          }
          break;

     case "Banners":
          $result = $this->step_Banners();
          break;

     case "BannersP":
          $result = $this->step_BannersP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Banners();
          }
          break;

     case "Reviews":
          $result = $this->step_Reviews();
          break;

     case "ReviewsP":
          $result = $this->step_ReviewsP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Reviews();
          }
          break;

     case "CustSale":
          $result = $this->step_CustSale();
          break;

     case "CustSaleP":
          $result = $this->step_CustSaleP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_CustSale();
          }
          break;

     case "CustShip":
          $result = $this->step_CustShip();
          break;

     case "CustShipP":
          $result = $this->step_CustShipP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_CustShip();
          }
          break;

     case "CustSurch":
          $result = $this->step_CustSurch();
          break;

     case "CustSurchP":
          $result = $this->step_CustSurchP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_CustSurch();
          }
          break;

     case "Final":
          $result = $this->step_Final();
          break;

     default:
          $result = $this->step_Default();
          break;

} // End of switch statement.

// +--
// | Return the result.
// +--

return $result;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Steps                                                   |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: step_Default                                           |
// +------------------------------------------------------------------+

function step_Default () {

// +--
// | Importer Function Step.
// +--

// +--
// | Default Invalid Info Screen
// | 
// | This function prints a page indicating the importer was hit 
// | with invalid information and prints a valid importer link.
// +--

$insname = $this->CORE->globals('importer.script_name');

print <<<ENDOFTEXT

<p>You have accessed this importer script using invalid data.  In 
order to use the importer script, please follow the link below:</p>

<p><a href="{$insname}" title="importer">Click here to run the importer script.</a></p>

ENDOFTEXT;

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Password                                          |
// +------------------------------------------------------------------+

function step_Password () {

// +--
// | Importer Function Step.
// +--

// +--
// | Password Collection
// | 
// | This function prints a form to be completed by the user to 
// | submit a password for this importer script.  This screen is 
// | accessed when a password already exists for the importer.
// +--

$software = $this->CORE->globals('importer.name');

print <<<ENDOFTEXT

<p>This data importer script is designed to import data from a {$software} 
installation into a new Kryptronic software installation.</p>

<p><strong>Items that are imported by this script</strong>: 
Settings, media files, customer, affiliate and wholesale accounts, affiliate payments, 
mail list guest subscribers, categories, products, product options, dynamic forms, 
orders, discount codes, HTML pages, news articles, reviews, custom sale scripts, 
custom shipping scripts and custom surcharge scripts.</p>

<p><strong>Items that are not imported by this script</strong>:  
Online processing settings, realtime shipping configuration information, 
checkout form modifications, general display changes made to system includes, and skins.</p>

ENDOFTEXT;

// +--
// | Define the form.
// +--

$header = <<<ENDOFTEXT

<p>This importer script is protected by a password that was set up
during the initial installation of this program.  Enter the password 
you selected to protect the installer script below then click the 
'Continue' button at the bottom of this page to import data using this 
importer script.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_password';
$fields[0]['name']     = 'Installer Password';
$fields[0]['type']     = 'PASSWORD';
$fields[0]['required'] = '1';

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Enter the password below that you selected to permit controlled 
access to the software installer.</p>

ENDOFTEXT;

$fields[1]['id']       = 'license_agree';
$fields[1]['name']     = 'License Agreement';
$fields[1]['type']     = 'CHECKBOX';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('1' => 'I agree to the terms and conditions in the EULA.');

$fields[1]['desc']     = <<<ENDOFTEXT

<p>Installation and use of this program requires you read and accept the 
End User License Agreement (EULA) distributed with this software.  Follow 
the link below to review the EULA.  The EULA is distributed in Adobe PDF 
format.  You will need Acrobat Reader, which is freely available from Adobe, 
to review the EULA.</p>

<p><a href="license.pdf" rel="external" title="License">Click here to review the EULA.</a></p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'Location'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Location                                          |
// +------------------------------------------------------------------+

function step_Location () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','1');
$this->CORE->globals('importer.steptext','Installation Location');

// +--
// | Print the form.
// +--

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below the full server path to the public config.php file 
for your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_pubconfig';
$fields[0]['name']     = 'Directory Path for Public Configuration File';
$fields[0]['type']     = 'TEXT-LONG';
$fields[0]['required'] = '1';

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Enter the absolute directory path to the public config.php file used by your 
{$software} installation.</p>

<p>Example: /home/username/public/config.php or C:/Inetpub/public/config.php</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'LocationP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_LocationP                                         |
// +------------------------------------------------------------------+

function step_LocationP () {

// +--
// | Importer Function Step
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig' => 1));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Strip off any trailing slashes and convert to Unix style
// | paths/filenames.
// +--

$import_pubconfig = $this->CORE->paths_convert($fd['import_pubconfig']);

$this->CORE->globals('core_cgi.import_pubconfig',$import_pubconfig);

// +--
// | Check the formdata submission items and append error messages as
// | we go.
// +--

$errorcount = 0;

$errmsg     = "The following errors were encountered while attempting 
               to process your request: ";

// +--
// | Check the file.
// +--

if (!(@file_exists($import_pubconfig))) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the public config.php used by your
                 software installation is incorrect.  The path specified does not exist.";

} // End of if statement.

// +--
// | Make sure it's valid.
// +--

$result = $this->import_load_configphp($import_pubconfig);

if (empty($result)) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the public config.php used by your
                 software installation is incorrect.  The file referenced is invalid.";

} // End of if statement.

// +--
// | Make sure software is installed.
// +--

$result = $this->CORE->globals('importer.import_install_db');

if (empty($result)) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the public config.php used by your
                 software installation is incorrect.  The file referenced points to an 
                 incomplete installation.";

} // End of if statement.

// +--
// | Attempt to connect to the database.
// +--

$result = $this->import_connect_db();

if (empty($result)) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the public config.php used by your
                 software installation is incorrect.  The file referenced refers to invalid 
                 database connection information.";

} // End of if statement.

// +--
// | Return errors if we have any at this point.
// +--

if ($errorcount) {

     $result = $this->CORE->RaiseError($errmsg);

     return $result;

} // End of if statement.

// +--
// | Print a confirmation message.
// +--

$message = "Thank you. The path to your public config.php file has been  validated.";

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_Settings();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Settings                                          |
// +------------------------------------------------------------------+

function step_Settings () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','2');
$this->CORE->globals('importer.steptext','Software Settings Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Software Settings';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'SettingsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_SettingsP                                         |
// +------------------------------------------------------------------+

function step_SettingsP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Software Settings';
$table    = 'core_settings';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Media();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Settings load
// +--

$loadsettings = array('core.accountenableajax', 'core.accountenableajaxcreate', 'core.accountenableajaxlogin', 'core.affilactive', 'core.banned_ips', 'core.basecurrency', 'core.basedimension', 'core.baseweight', 'core.createaccountform', 'core.curractive', 'core.currcdp.AUD', 'core.currcdp.CAD', 'core.currcdp.CHF', 'core.currcdp.EUR', 'core.currcdp.GBP', 'core.currcdp.JPY', 'core.currcdp.USD', 'core.currconv.AUD', 'core.currconv.CAD', 'core.currconv.CHF', 'core.currconv.EUR', 'core.currconv.GBP', 'core.currconv.JPY', 'core.currconv.USD', 'core.currcth.AUD', 'core.currcth.CAD', 'core.currcth.CHF', 'core.currcth.EUR', 'core.currcth.GBP', 'core.currcth.JPY', 'core.currcth.USD', 'core.currsym.AUD', 'core.currsym.CAD', 'core.currsym.CHF', 'core.currsym.EUR', 'core.currsym.GBP', 'core.currsym.JPY', 'core.currsym.USD', 'core.datetime_format', 'core.datetime_incdec', 'core.datetime_offset', 'core.db_resultspp', 'core.docookieinfo', 'core.enabletooltips', 'core.postcodeanywhere_acctcode', 'core.postcodeanywhere_active', 'core.postcodeanywhere_liccode', 'core.seo_googleacct', 'core.seo_googleadwords', 'core.session_logoutminbe', 'core.session_logoutminfe', 'core.show_addbook', 'core.site_name', 'core.sitemap_se', 'core.sitemap_showcats', 'core.sitemap_showhtml', 'core.sitemap_showprods', 'core.sitemap_status', 'core.siteowneradd', 'core.siteownercity', 'core.siteownercountry', 'core.siteowneremail', 'core.siteownerphone', 'core.siteownerstateprov', 'core.siteownerzip', 'core.skins_maillogo', 'core.skins_mainlogo', 'core.skins_printlogo', 'core.stats_status', 'core.taxcompanyeuaff', 'core.taxcompanyeunumber', 'core.taxcountry', 'core.taxcountryeudisp', 'core.taxcountryeuentry', 'core.taxcountryeuhome', 'core.taxcountryeuname', 'core.taxcountryeutextexcl', 'core.taxcountryeutextincl', 'core.taxcountryeutextzero', 'core.taxcountryeuzero', 'core.taxcountrystdname', 'core.taxcountrysys', 'core.taxstateprov', 'core.taxvalidateeunum', 'core.taxvateunumber', 'core.time_store_tempfiles', 'core.upload_maxsize', 'core.whlactive', 'ecom.activateminicartajax', 'ecom.activateprodsearchajax', 'ecom.allowguestco', 'ecom.cartdispimg', 'ecom.cartwlupsellname', 'ecom.cartwlupsellslider', 'ecom.checkoutenableajax', 'ecom.dispprodoptlinebr', 'ecom.enablecartwlajax', 'ecom.enablecartwlupsell', 'ecom.enablewishlist', 'ecom.featprodname1', 'ecom.featprodname2', 'ecom.featprodname3', 'ecom.featprodname4', 'ecom.featprodname5', 'ecom.featprodslider1', 'ecom.featprodslider2', 'ecom.featprodslider3', 'ecom.featprodslider4', 'ecom.featprodslider5', 'ecom.fedexretcurr', 'ecom.freeshipamt', 'ecom.guestcoform', 'ecom.imagesminicartajax', 'ecom.loyaltypoints_active', 'ecom.loyaltypoints_createacct', 'ecom.loyaltypoints_name', 'ecom.loyaltypoints_value', 'ecom.maxpackageweight', 'ecom.minorderamt', 'ecom.ordernumprefix', 'ecom.ordernumtype', 'ecom.paypalproapiurl', 'ecom.paypalprocurr', 'ecom.paypalproexpemail', 'ecom.paypalproexplink', 'ecom.paypalprokey', 'ecom.paypalpropass', 'ecom.paypalprosig', 'ecom.paypalprouser', 'ecom.presdimerr', 'ecom.presweighterr', 'ecom.prodshow_social_facebook', 'ecom.prodshow_social_googleplus', 'ecom.prodshow_social_linkedin', 'ecom.prodshow_social_pinterest', 'ecom.prodshow_social_twitter', 'ecom.prodshowimgpop', 'ecom.prodshowimgzoom', 'ecom.prodshowpriceautoupdate', 'ecom.relatedprods', 'ecom.relprodname', 'ecom.relprodslider', 'ecom.reviews_numshow', 'ecom.reviews_reqaccount', 'ecom.reviews_reqauth', 'ecom.reviews_slider', 'ecom.reviews_status', 'ecom.salescript', 'ecom.shipdestallow', 'ecom.shiperramt', 'ecom.shiperrname', 'ecom.shipestimator_status', 'ecom.shiphandlecharge', 'ecom.shiphandzero', 'ecom.shipminheight', 'ecom.shipminlength', 'ecom.shipminweight', 'ecom.shipminwidth', 'ecom.showinstock', 'ecom.showinstocklevel', 'ecom.showsortopts', 'ecom.splashprodname', 'ecom.splashprodslider', 'ecom.surchargescript', 'ecom.time_store_carts', 'ecom.time_store_orderspend', 'ecom.upsaccountnum', 'ecom.upsnegrates', 'ecom.usesalescript', 'ecom.usesurchargescript', 'ecom.uspsretcurr', 'ecom.xmodgooglebase_channeldescription', 'ecom.xmodgooglebase_payments', 'ecom.xmodgooglebase_status', 'ecom.xmodthub_connpass', 'ecom.xmodthub_connuser', 'ecom.xmodthub_status', 'ecom.xmodthub_timezone');

// +--
// | Load settings to be imported.
// +--

$old_settings = array();

$sql  = 'SELECT id, displaytype, value FROM ' . $table . ' WHERE ';

foreach ($loadsettings as $lsnum => $lsid) {$sql .= 'id=' . $this->CORE_DBX->quote($lsid) . ' OR ';}

$sql = preg_replace('/ OR $/','',$sql);

$old_settings = $this->CORE_DBX->sql_do(array('sql'   => $sql,
                                              'table' => $table,
                                              'order' => array('id' => 'ASC')));

if (($this->CORE->IsError($old_settings)) || (empty($old_settings))) {$old_settings = array();}

if (empty($old_settings)) {

     $message  = 'Thank you.  All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Media();

} // End of if statement.

// +--
// | Loop through and make updates.
// +--

$settingscopy = array('core.siteowneradd'       => 'ecom.localwarehouseaddone',
                      'core.siteownercity'      => 'ecom.localwarehousecity',
                      'core.siteownerstateprov' => 'ecom.localwarehousestateprov',
                      'core.siteownercountry'   => 'ecom.localwarehousecountry',
                      'core.siteownerzip'       => 'ecom.localwarehousezip');

$import_cryptkey = $this->CORE->globals('importer.import_cryptkey');

foreach ($old_settings as $osnum => $osdata) {

     if (($osdata['displaytype'] == 'TEXTBOX-CRYPT') && (!(empty($import_cryptkey)))) {

          $osdata['value'] = $this->CORE_Crypt->decrypt($osdata['value'],$import_cryptkey);

          $osdata['value'] = $this->CORE_Crypt->encrypt($osdata['value']);                

     } // End of if statement.

     $data = array('value' => $osdata['value']);

     $update_clause = $this->CORE_DB->clause_update(array('table' => $table,
                                                          'data'  => $data));

     if (!($this->CORE->IsError($update_clause))) {

          $sql = $update_clause . ' WHERE id=' . $this->CORE_DB->quote($osdata['id']);

          $result = $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

          if (!(empty($settingscopy[$osdata['id']]))) {

               $sql = $update_clause . ' WHERE id=' . $this->CORE_DB->quote($settingscopy[$osdata['id']]);

               $result = $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

          } // End of if statement.

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print a confirmation message.
// +--

$message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_Media();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Media                                             |
// +------------------------------------------------------------------+

function step_Media () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','3');
$this->CORE->globals('importer.steptext','Media File Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Media Files';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'MediaP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_MediaP                                            |
// +------------------------------------------------------------------+

function step_MediaP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Media Files';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_CustAcct();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle importing the data.
// +--

$dirdlsrc    = $this->CORE->globals('importer.import_path_private')  . '/downloads';
$dirmedia    = $this->CORE->globals('importer.import_path_public') . '/media';
$destdlsrc   = $this->CORE->globals('core.path_private') . '/downloads';
$destmedia   = $this->CORE->globals('core.path_public') . '/media';

$translation = array($dirdlsrc                   => $destdlsrc,
                     $dirmedia . '/cms/html'     => $destmedia . '/cms/html',
                     $dirmedia . '/skins/logos'  => $destmedia . '/skins/logos');

foreach ($translation as $source => $dest) {

     $files  = array();

     $handle = @opendir($source);

     if (!(empty($handle))) {

          while (false !== ($file = @readdir($handle))) {

               if (($file != 'dir.txt') && (!(preg_match('/\.ht/',$file))) && (is_file($source . '/' . $file))) {

                    if (!(file_exists($dest))) {

                         $this->CORE_File->make_dir($dest);

                    } // End of if statement.

                    if ((!(file_exists($dest . '/' . $file))) || ($dest == $destmedia . '/skins/logos')) {

                         $this->CORE_File->copy(array('source' => $source . '/' . $file,
                                                      'dest'   => $dest . '/' . $file));

                    } // End of if statement.

               } // End of if statement.

          } // End of while statement.

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print a confirmation message.
// +--

$message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_CustAcct();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustAcct                                          |
// +------------------------------------------------------------------+

function step_CustAcct () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','4');
$this->CORE->globals('importer.steptext','Customer Account Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Customer Accounts';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$header .= '<p><strong>Please Note: Customer accounts with management interface access ';
$header .= 'will not be imported in an effort to maintain system security.</strong></p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'CustAcctP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustAcctP                                         |
// +------------------------------------------------------------------+

function step_CustAcctP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Customer Accounts';
$table    = 'core_users';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Affiliates();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'CustAcctP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $sql  = 'DELETE FROM ' . $table . ' WHERE usergroup<>' . $this->CORE_DB->quote('superuser') . ' AND ';
     $sql .= 'usergroup<>' . $this->CORE_DB->quote('admin') . ' AND ';
     $sql .= 'usergroup<>' . $this->CORE_DB->quote('reports');

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => $table));

} // End of if statement.

// +--
// | Loop through the data.  Backend users are not loaded.
// +--

$eol = $this->CORE->globals('core.eol');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Bad character removal from id-related fields.
          // +--

          $row['id'] = preg_replace('/[^A-Za-z0-9\.\-\_\@]/','',$row['id']);

          // +--
          // | Subscription change
          // +--

          if ((!(empty($row['subscriptions']))) && ($import_dbimptype == 'SAVE')) {

               $this->CORE_DB->sql_save(array('table'  => 'core_emaillist',
                                              'data'   => array('id' => $row['id'], 'fname' => $row['fname'], 'lname' => $row['lname'], 'liststatus' => 1),
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } elseif (!(empty($row['subscriptions']))) {

               $sql = $this->CORE_DB->clause_insert(array('table' => 'core_emaillist', 
                                                          'data'  => array('id' => $row['id'], 'fname' => $row['fname'], 'lname' => $row['lname'], 'liststatus' => 1)));

               if (!($this->CORE->IsError($sql))) {$this->CORE_DB->sql_do(array('sql'   => $sql, 'table' => 'core_emaillist'));}


          } // End of if statement.

          // +--
          // | New columns and data changes.
          // +--

          $row['acctsyspri']         = '';
          $row['acctsysprimod']      = 0;
          $row['acctsysalt']         = '';
          $row['acctsysaltmod']      = 0;
          $row['affilsalestodate']   = '0.00';
          $row['affilcommearned']    = '0.00';
          $row['affilcommowed']      = '0.00';
          $row['affilcommpaid']      = '0.00';
          $row['affilmaxcommpct']    = '0.000';
          $row['affillockid ']       = '';
          $row['billdamageclaim']    = 0;
          $row['custorderemails']    = '';
          $row['disableorderemails'] = 0;
          $row['ordemaillogosup']    = 0;
          $row['freeshipamt']        = '0.00';
          $row['intorderemails']     = '';
          $row['lphistearn']         = $row['loyaltypoints'];
          $row['lphistspend']        = 0;
          $row['olpdata']            = serialize(array());
          $row['purchonacct']        = 0;
          $row['sessdata']           = '';
          $row['taxexemptnum']       = '';
          $row['uanotes']            = '';

          $row['ktokenuser']       = '';
          $row['ktokenauth']       = '';
          $row['kcodeauth']        = '';
          $row['ktokendevauth']    = '';
          $row['loginfails']       = '0';
          $row['loginfaillast']    = '0';
          $row['loginlocked']      = '0';
          $row['passchangelast']   = $row['lastaccess'];
          $row['passchangehist']   = '';

          $row['customdata']        = '';
          $row['acctsystermsavail'] = '';
	  $row['autocommentsint']   = '';
          $row['invoicemail']       = '0';
          $row['invoicedisp']       = '0';	  	  

          if ($row['usergroup'] == 'wholesale') {$row['whlsalepct'] = 'DEFAULT|' . $row['whlsalepct'] . '|' . $row['whlsalepct'];}
          else                                  {$row['whlsalepct'] = 'DEFAULT|0.000|0.000';}

          if (empty($row['username'])) {$row['username'] = $this->CORE->random_number(10);}

          if (($row['usergroup'] != 'users') && ($row['usergroup'] != 'superuser') && ($row['usergroup'] != 'reports') && ($row['usergroup'] != 'wholesale') && ($row['usergroup'] != 'admin')) {

               $row['usergroup'] = 'users';

          } // End of if statement.

          // +--
          // | Delete old, unused columns.
          // +--

          unset($row['subscriptions']);
          unset($row['affilcommpct']);
          unset($row['lastsid']);

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Affiliates();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Affiliates                                        |
// +------------------------------------------------------------------+

function step_Affiliates () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','5');
$this->CORE->globals('importer.steptext','Affiliate Payments Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Affiliate Payments';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'AffiliatesP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_AffiliatesP                                       |
// +------------------------------------------------------------------+

function step_AffiliatesP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Affiliate Payments';
$table    = 'core_affpay';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_MailList();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'AffiliatesP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $sql  = 'DELETE FROM ' . $table;

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => $table));

} // End of if statement.

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_MailList();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Maillist                                          |
// +------------------------------------------------------------------+

function step_Maillist () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','6');
$this->CORE->globals('importer.steptext','Email List Subscriber Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Email List Subscribers';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'MaillistP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_MaillistP                                         |
// +------------------------------------------------------------------+

function step_MaillistP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Email List Subscribers';
$table    = 'core_guestsub';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Category();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'MaillistP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          $thisrow = array('id' => $row['id'], 'fname' => '', 'lname' => '', 'liststatus' => 1);

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => 'core_emaillist',
                                              'data'   => $thisrow,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => 'core_emaillist',
                                                          'data'  => $thisrow));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => 'core_emaillist'));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Category();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Category                                          |
// +------------------------------------------------------------------+

function step_Category () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','7');
$this->CORE->globals('importer.steptext','Category Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Categories';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'CategoryP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CategoryP                                         |
// +------------------------------------------------------------------+

function step_CategoryP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Categories';
$table    = 'ecom_cat';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_ProdOpt();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'CategoryP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $sql  = 'DELETE FROM ' . $table;

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => $table));

} // End of if statement.

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     // +--
     // | Category parent definitions.
     // +--

     $catparent = array();

     $xdata = $this->CORE_DBX->sql_do(array('sql'    => 'SELECT id, splashdisp, xcat FROM ecom_cat WHERE xcat<>' . $this->CORE_DBX->quote(''),
                                            'table'  => 'ecom_cat',
                                            'order'  => array('splashdisp' => 'DESC', 'sortorder' => 'DESC')));

     if ((!($this->CORE->IsError($xdata))) && (!(empty($xdata)))) {

          foreach ($xdata as $xnum => $xrow) {

               $xid  = preg_replace('/[^a-zA-Z0-9\_\-]/','',$xrow['id']);
               $xcat = $this->CORE->make_list($xrow['xcat']);
               $xcat = array_reverse($xcat);

               foreach ($xcat as $xcnum => $xcid) {

                    $xcid = preg_replace('/[^a-zA-Z0-9\_\-]/','',$xcid);

                    if (!(empty($catparent[$xcid]))) {continue;}

                    $catparent[$xcid] = $xid;

               } // End of foreach statement.

          } // End of foreach statement.

     } // End of if statement.

     // +--
     // | Continue...
     // +--

     foreach ($data as $num => $row) {

          // +--
          // | Bad character removal from id-related fields.
          // +--

          $row['id'] = preg_replace('/[^a-zA-Z0-9\_\-]/','',$row['id']);

          $col       = 'xcat';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = ''; foreach ($xdata as $xnum => $xid) {if (empty($xid)) {continue;} $row[$col] .= preg_replace('/[^a-zA-Z0-9\_\-]/','',$xid) . ', ';}
          $row[$col] = preg_replace('/\, $/','',$row[$col]);

          // +--
          // | Image
          // +--

          if (!(empty($row['catimg']))) {

              $filesrc  = $this->CORE->globals('importer.import_path_public') . '/media/ecom/cat/' . $row['catimg'];
              $filedest = $this->CORE->globals('core.path_public') . '/media/ecom/cat/' . $row['catimg'];

              if     (!(@file_exists($filesrc)))  {$row['catimg'] = '';}
              elseif (!(@file_exists($filedest))) {$this->CORE_File->copy(array('source' => $filesrc, 'dest' => $filedest));}

          } // End of if statement.

          if (empty($row['catimg'])) {$row['catimg'] = 'none.png';}

          // +--
          // | New columns and data changes.
          // +--

          $row['addldisp']               = 'DEFAULT';
          $row['bannergroup']            = '';
          $row['cathighlights']          = '';
          $row['descshort']              = '';
          $row['manusortorder']          = $row['sortorder'];
          $row['multisitedescone']       = '';
          $row['multisitedescshortone']  = '';
          $row['multisitedesconelimit']  = '';
          $row['multisitedesctwo']       = '';
          $row['multisitedescshorttwo']  = '';
          $row['multisitedesctwolimit']  = '';
          $row['seoexact']               = 0;
          $row['specbannergroup']        = '';
          $row['speccatimg']             = '';
          $row['specdescription']        = '';
          $row['specdescshort']          = '';
          $row['specname']               = '';
          $row['subdisp']                = 'DEFAULT';
          $row['videourl']               = '';
          $row['xmultisite']             = '';
          $row['xsortorder']             = 0;

          $row['catparent'] = ''; if ((empty($row['splashdisp'])) && (!(empty($catparent[$row['id']])))) {$row['catparent'] = $catparent[$row['id']];}

          // +--
          // | Delete old, unused columns.
          // +--

          unset($row['catmulti']);
          unset($row['datetimestamp']);
          unset($row['proddisptype']);
          unset($row['proddispnum']);
          unset($row['subdisptype']);
          unset($row['subdispnum']);

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_ProdOpt();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProdOpt                                           |
// +------------------------------------------------------------------+

function step_ProdOpt () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','8');
$this->CORE->globals('importer.steptext','Product Option Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Product Options';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'ProdOptP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProdOptP                                          |
// +------------------------------------------------------------------+

function step_ProdOptP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Product Options';
$table    = 'ecom_prodoptions';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Product();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'ProdOptP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $sql  = 'DELETE FROM ' . $table . ' WHERE id<>' . $this->CORE_DB->quote('CUSTOMSERV-DESCRIPTION') . ' AND id<>' . $this->CORE_DB->quote('MISCINVITEM-DESCRIPTION') . ' AND ';
     $sql .= 'id<>' . $this->CORE_DB->quote('OVERPAYMENT-DESCRIPTION') . ' AND id<>' . $this->CORE_DB->quote('AMAZONREIMBURSEMENT-DESCRIPTION');

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => $table));

} // End of if statement.

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Load option selection items, if necessary.
          // +--

          $thisoptsel = '';
          $eol        = $this->CORE->globals('core.eol');

          if ((!(empty($row['xprodoptionsel']))) && (preg_match('/\-CUSTOM$/',$row['fieldtype']))) {

               $sql   = 'SELECT * FROM ecom_prodoptionsel WHERE ';
               $xdata = $this->CORE->make_list($row['xprodoptionsel']);

               foreach ($xdata as $xnum => $xid) {$sql .= 'id=' . $this->CORE_DBX->quote($xid) . ' OR ';}

               $sql = preg_replace('/ OR $/','',$sql);

               $xdata = $this->CORE_DBX->sql_do(array('sql'    => $sql,
                                                      'table'  => 'ecom_prodoptionsel',
                                                      'order'  => array('fieldorder' => 'ASC')));

               if ((!($this->CORE->IsError($xdata))) && (!(empty($xdata)))) {

                    $xcount = 0;

                    foreach ($xdata as $xnum => $xrow) {

                         if ($xrow['pricechngreg'] <= 0) {$xrow['pricechngreg'] = 0;}
                         if ($xrow['pricechngwhl'] <= 0) {$xrow['pricechngwhl'] = 0;}

                         $xrow['pricechngreg'] = sprintf("%.2f",round($xrow['pricechngreg'],2));
                         $xrow['pricechngwhl'] = sprintf("%.2f",round($xrow['pricechngwhl'],2));

                         $thisoptsel .= $xrow['name'] . '|' . $xrow['pricechngreg'] . '|' . $xrow['pricechngwhl'] . '|';
                         $thisoptsel .= $xrow['loyaltypoints'] . '|' . $xrow['taxclass'] . '|' . $xrow['taxstateprov'] . '|';
                         $thisoptsel .= $xrow['taxcountry'] . '|' . $xrow['downloadfile'];

                         $xcount++; if ($xcount != count($xdata)) {$thisoptsel .= $eol;}

                    } // End of foreach statement.

               } // End of if statement.

          } // End of if statement.

          // +--
          // | Bad character removal from id-related fields.
          // +--

          $row['id'] = preg_replace('/[^a-zA-Z0-9\_\-]/','',$row['id']);

          // +--
          // | New columns and data changes.
          // +--

          $row['optsel'] = $thisoptsel;

          if (empty($row['section'])) {$row['section'] = 'Item Options';}

          // +--
          // | Delete old, unused columns.
          // +--

          unset($row['useinventory']);
          unset($row['xprodoptionsel']);

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Product();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Product                                           |
// +------------------------------------------------------------------+

function step_Product () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','9');
$this->CORE->globals('importer.steptext','Product Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Products';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'ProductP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProductP                                          |
// +------------------------------------------------------------------+

function step_ProductP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Products';
$table    = 'ecom_prod';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Orders();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'ProductP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $sql  = 'DELETE FROM ' . $table . ' WHERE id<>' . $this->CORE_DB->quote('GIFTCERTIFICATE') . ' AND id<>' . $this->CORE_DB->quote('OVERPAYMENT');
     $sql .= ' AND id<>' . $this->CORE_DB->quote('CUSTOMSERV') . ' AND id<>' . $this->CORE_DB->quote('WARRANTYREPLACE');
     $sql .= ' AND id<>' . $this->CORE_DB->quote('WARRANTYRETURN') . ' AND id<>' . $this->CORE_DB->quote('DAMAGECLAIMREPLACE');
     $sql .= ' AND id<>' . $this->CORE_DB->quote('DAMAGECLAIMRETURN') . ' AND id<>' . $this->CORE_DB->quote('AMAZONREIMBURSEMENT');

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => $table));

     $sql  = 'DELETE FROM ecom_pricemap WHERE channelid=' . $this->CORE_DB->quote('DEFAULT') . ' AND xofferid<>' . $this->CORE_DB->quote('GIFTCERTIFICATE');
     $sql .= ' AND xofferid<>' . $this->CORE_DB->quote('CUSTOMSERV') . ' AND xofferid<>' . $this->CORE_DB->quote('WARRANTYREPLACE');
     $sql .= ' AND xofferid<>' . $this->CORE_DB->quote('WARRANTYRETURN') . ' AND xofferid<>' . $this->CORE_DB->quote('DAMAGECLAIMREPLACE');
     $sql .= ' AND xofferid<>' . $this->CORE_DB->quote('DAMAGECLAIMRETURN') . ' AND xofferid<>' . $this->CORE_DB->quote('OVERPAYMENT') . ' AND xofferid<>' . $this->CORE_DB->quote('AMAZONREIMBURSEMENT');

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => 'ecom_pricemap'));

     $sql  = 'DELETE FROM ecom_inventory WHERE id<>' . $this->CORE_DB->quote('CHANNELNOMATCH');
     $sql .= ' AND id<>' . $this->CORE_DB->quote('DAMAGECLAIMREPLACE') . ' AND id<>' . $this->CORE_DB->quote('DAMAGECLAIMRETURN');
     $sql .= ' AND id<>' . $this->CORE_DB->quote('MISCINVITEM') . ' AND id<>' . $this->CORE_DB->quote('WARRANTYREPLACE');
     $sql .= ' AND id<>' . $this->CORE_DB->quote('WARRANTYRETURN');

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => 'ecom_inventory'));

} // End of if statement.

// +--
// | Loop through the data.
// +--

$eol = $this->CORE->globals('core.eol');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     // +--
     // | Load vendors.
     // +--

     $vendors    = array();
     $sql        = 'SELECT id FROM ecom_vendors';
     $xdata      = $this->CORE_DB->sql_do(array('sql'   => $sql, 'table' => 'ecom_vendors','order' => array('id'=>'ASC')));

     if ((!($this->CORE->IsError($xdata))) && (!(empty($xdata)))) {foreach ($xdata as $xnum => $xrow) {$vendors[$xrow['id']] = 1;}}

     // +--
     // | Load local warehouse settings.
     // +--

     $settings = array();
     $sql      = 'SELECT id, value FROM core_settings WHERE id LIKE ' . $this->CORE_DB->quote_like('ecom.localwarehouse','SUFFIX') . ' OR id=' . $this->CORE_DB->quote('core.siteowneremail');
     $xdata    = $this->CORE_DB->sql_do(array('sql'   => $sql, 'table' => 'core_settings','order' => array('id'=>'ASC')));

     if ((!($this->CORE->IsError($xdata))) && (!(empty($xdata)))) {foreach ($xdata as $xnum => $xrow) {$settings[$xrow['id']] = $xrow['value'];}}

     // +--
     // | Continue...
     // +--

     foreach ($data as $num => $row) {

          // +--
          // | Bad character removal from id-related fields.
          // +--

          $row['id'] = preg_replace('/[^a-zA-Z0-9\_\-]/','',$row['id']);

          $col       = 'xcat';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = ''; foreach ($xdata as $xnum => $xid) {if (empty($xid)) {continue;} $row[$col] .= preg_replace('/[^a-zA-Z0-9\_\-]/','',$xid) . ', ';}
          $row[$col] = preg_replace('/\, $/','',$row[$col]);

          $col       = 'xprod';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = ''; foreach ($xdata as $xnum => $xid) {if (empty($xid)) {continue;} $row[$col] .= preg_replace('/[^a-zA-Z0-9\_\-]/','',$xid) . ', ';}
          $row[$col] = preg_replace('/\, $/','',$row[$col]);

          $col       = 'xupsell';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = ''; foreach ($xdata as $xnum => $xid) {if (empty($xid)) {continue;} $row[$col] .= preg_replace('/[^a-zA-Z0-9\_\-]/','',$xid) . ', ';}
          $row[$col] = preg_replace('/\, $/','',$row[$col]);

          $col       = 'xprodoptions';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = ''; foreach ($xdata as $xnum => $xid) {if (empty($xid)) {continue;} $row[$col] .= preg_replace('/[^a-zA-Z0-9\_\-]/','',$xid) . ', ';}
          $row[$col] = preg_replace('/\, $/','',$row[$col]);

          // +--
          // | Image: Small
          // +--

          if (!(empty($row['imgsm']))) {

              $filesrc  = $this->CORE->globals('importer.import_path_public') . '/media/ecom/prodsm/' . $row['imgsm'];
              $filedest = $this->CORE->globals('core.path_public') . '/media/ecom/prodsm/' . $row['imgsm'];

              if     (!(@file_exists($filesrc)))  {$row['imgsm'] = '';}
              elseif (!(@file_exists($filedest))) {$this->CORE_File->copy(array('source' => $filesrc, 'dest' => $filedest));}

          } // End of if statement.

          if (empty($row['imgsm'])) {$row['imgsm'] = 'none.png';}

          // +--
          // | Image: Large
          // +--

          if (!(empty($row['imglg']))) {

              $imglist      = $this->CORE->make_list($row['imglg']);
              $row['imglg'] = '';

              foreach ($imglist as $ilnum => $ilname) {

                   $filesrc   = $this->CORE->globals('importer.import_path_public') . '/media/ecom/prodlg/' . $ilname;
                   $filesrcxl = $this->CORE->globals('importer.import_path_public') . '/media/ecom/prodxl/' . $ilname;
                   $filedest  = $this->CORE->globals('core.path_public') . '/media/ecom/prodlg/' . $ilname;

                   if ((!(@file_exists($filesrc))) && (!(@file_exists($filesrcxl)))) {continue;}

                   $row['imglg'] .= $ilname . ', ';

                   if (@file_exists($filedest))                                      {continue;}

                   if     (@file_exists($filesrcxl)) {$this->CORE_File->copy(array('source' => $filesrcxl, 'dest' => $filedest));}
                   elseif (@file_exists($filesrc))   {$this->CORE_File->copy(array('source' => $filesrc, 'dest' => $filedest));}

              } // End of if statement.

              $row['imglg'] = preg_replace('/\, $/','',$row['imglg']);

          } // End of if statement.

          if (empty($row['imglg'])) {$row['imglg'] = 'none.png';}

          // +--
          // | Fix product option strings.
          // +--

          $col       = 'xprodoptions';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = ''; foreach ($xdata as $xnum => $xid) {if (empty($xid)) {continue;} $row[$col] .= $xid . ', ';}
          $row[$col] = preg_replace('/\, $/','',$row[$col]);

          // +--
          // | Create new inventory items.
          // +--

          $invitemid = '';

          if (($row['delmethod'] != 'N') && ($row['pricestatus'] != 'D')) {

               $invitem   = array();
               $invitemid = $row['id'];

               $invitem['id']                    = $row['id'];
               $invitem['name']                  = $row['name'];
               $invitem['prodnum']               = $row['prodnum'];
               $invitem['manufacturer']          = 'DEFAULT';
               $invitem['imgsm']                 = $row['imgsm'];
               $invitem['discexclusions']        = '';
               $invitem['suppressreport']        = 0;
               $invitem['barcode']               = '';
               $invitem['vendorid']              = 'DEFAULT';
               $invitem['vendoritemid']          = $row['prodnum'];
               $invitem['vendordesc']            = $row['name'];
               $invitem['purchcosteach']         = '0.00';
               $invitem['purchcostdropeach']     = '0.00';
               $invitem['avgcosteach']           = '0.00';
               $invitem['mapprice']              = '0.00';
               $invitem['mappricewhl']           = '0.00';
               $invitem['acctsysprice']          = sprintf("%.2f",round($row['regprice']));
               $invitem['casequantity']          = '1';
               $invitem['casebarcode']           = '';
               $invitem['acctsysasset']          = 'asset-inventory';
               $invitem['acctsyscogs']           = 'cogs-default';
               $invitem['acctsysincome']         = 'income-invitem';
               $invitem['acctsyspri']            = '';
               $invitem['acctsysalt']            = '';
               $invitem['acctsysprimod']         = 0;
               $invitem['acctsysaltmod']         = 0;
               $invitem['invtype']               = 'LOCALUNL';
               $invitem['invtypewhl']            = 'LOCALUNL';
               $invitem['notifystock']           = $row['notifystock'];
               $invitem['invlevel']              = $row['invlevel'];
               $invitem['invlevelremote']        = 0;
               $invitem['invoversell']           = 0;
               $invitem['invsalesorder']         = 0;
               $invitem['invshipmanager']        = 0;
               $invitem['invpurchord']           = 0;
               $invitem['warehouseloc']          = 'A1';
               $invitem['delmethod']             = $row['delmethod'];
               $invitem['shipnumbox']            = $row['shipnumbox'];
               $invitem['servreq']               = 0;
               $invitem['shipmustrate']          = 0;
               $invitem['shipfreethreshtrigger'] = 0;
               $invitem['shipfreeoverride']      = '0.00';
               $invitem['customship']            = $row['customship'];
               $invitem['shiponename']           = $row['shiponename'];
               $invitem['shiponeprice']          = $row['shiponeprice'];
               $invitem['shiptwoname']           = $row['shiptwoname'];
               $invitem['shiptwoprice']          = $row['shiptwoprice'];
               $invitem['shipthreename']         = $row['shipthreename'];
               $invitem['shipthreeprice']        = $row['shipthreeprice'];
               $invitem['shiplocal']             = $row['shiplocal'];
               $invitem['shipint']               = $row['shipint'];
               $invitem['shiplength']            = $row['shiplength'];
               $invitem['shipwidth']             = $row['shipwidth'];
               $invitem['shipheight']            = $row['shipheight'];
               $invitem['shipweight']            = $row['shipweight'];
               $invitem['shipnest']              = '0.0';
               $invitem['xprodoptions']          = $row['xprodoptions'];
               $invitem['xprodoptionsdisp']      = 'DEFAULT, ADDON';
               $invitem['addemtext']             = $row['addemtext'];
               $invitem['customdata']            = '';

               // +--
               // | Ship Location / Vendor Changes
               // +--

               if (!(empty($row['shipemail']))) {$shipemail = $this->CORE->make_list($row['shipemail']); $row['shipemail'] = $shipemail[0];}

               if ($row['shipemail'] == $settings['core.siteowneremail']) {$row['shipemail'] = '';}

               $isoffsite = 1;

               if ((empty($row['shipstateprov'])) || (empty($row['shipcountry'])) || (empty($row['shipzip']))) {

                    $row['shipstateprov'] = $settings['ecom.localwarehousestateprov'];
                    $row['shipcountry']   = $settings['ecom.localwarehousecountry'];
                    $row['shipzip']       = $settings['ecom.localwarehousezip'];

                    $isoffsite = 0;

               } // End of if statement.

               if ((!(empty($isoffsite))) || (!(empty($row['shipemail'])))) {

                    if (!(empty($row['shipemail']))) {

                         $vendor = array('id'       => strtoupper(preg_replace('/^(.*)\@(.*)\.(.*)/','\\2',$row['shipemail']) . '-' . $row['shipzip']),
                                         'name'     => ucfirst(strtolower(preg_replace('/^(.*)\@(.*)\.(.*)/','\\2',$row['shipemail']))) . ' (' . $row['shipzip'] . ')',
                                         'custacct' => $row['shipemail']);

                    } else {

                         if ($row['shipstateprov'] == 'Not Applicable') {

                              $vendor = array('id'       => strtoupper($row['shipcountry'] . '-' . $row['shipzip']),
                                              'name'     => $vendor['name'] = $row['shipcountry'] . ' (' . $row['shipzip'] . ')',
                                              'custacct' => $settings['core.siteowneremail']);

                         } else {

                              $vendor = array('id'       => strtoupper($row['shipstateprov'] . '-' . $row['shipzip']),
                                              'name'     => $row['shipstateprov'] . ' (' . $row['shipzip'] . ')',
                                              'custacct' => $settings['core.siteowneremail']);

                         } // End of if statement.

                    } // End of if statement.

                    $vendor['id']        = preg_replace('/[^0-9a-zA-Z\_\-]/','',$vendor['id']);
                    $invitem['vendorid'] = $vendor['id'];

                    if (empty($vendors[$vendor['id']])) {

                         $vendor['minorder']        = '0.00';
                         $vendor['shiptime']        = 5;
                         $vendor['purchacctref']    = '';
                         $vendor['purchemail']      = '';
                         $vendor['shipstateprov']   = $row['shipstateprov'];
                         $vendor['shipcountry']     = $row['shipcountry'];
                         $vendor['shipzip']         = $row['shipzip'];
                         $vendor['acctsyspri']      = '';
                         $vendor['acctsysalt']      = '';
                         $vendor['acctsysprimod']   = 0;
                         $vendor['acctsysaltmod']   = 0;
                         $vendor['purchterms']      = 'Net 30';
                         $vendor['purchshipmethod'] = 'STANDARD';

                         $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_vendors', 'data'   => $vendor));

                         if (!($this->CORE->IsError($sql))) {$this->CORE_DB->sql_do(array('sql'   => $sql, 'table' => 'ecom_vendors'));}

                         $vendors[$vendor['id']] = 1;

                    } // End of if statement.

               } // End of if statement.

               // +--
               // | Pricing and Images
               // +--

               if ($row['pricestatus'] == 'S') {$invitem['acctsysprice'] = sprintf("%.2f",round($row['saleprice']));}

               if     ((!(empty($row['useinv']))) && (!(empty($row['shipemail'])))) {$invitem['invtype']  = 'LOCALINVDROPUNL'; $invitem['invtypewhl']  = 'LOCALINVDROPUNL';}
               elseif (!(empty($row['useinv'])))                                    {$invitem['invtype']  = 'LOCALINV'; $invitem['invtypewhl']  = 'LOCALINV';}
               elseif (!(empty($row['shipemail'])))                                 {$invitem['invtype']  = 'DROPUNL'; $invitem['invtypewhl']  = 'DROPUNL'; $invitem['invlevel'] = 0;}
               else                                                                 {$invitem['invlevel'] = 0;}

               if (empty($invitem['shiponename'])) {$invitem['shiponename'] = 'Default Carrier';}

               if (!(empty($row['imgsm']))) {

                   $filesrc  = $this->CORE->globals('importer.import_path_public') . '/media/ecom/prodsm/' . $row['imgsm'];
                   $filedest = $this->CORE->globals('core.path_public') . '/media/ecom/invsm/' . $row['imgsm'];

                   if (!(@file_exists($filedest))) {$this->CORE_File->copy(array('source' => $filesrc, 'dest' => $filedest));}

               } // End of if statement.

               $row['xprodoptions']     = '';
               $row['addemtext']        = '';

               // +--
               // | DB Updates
               // +--

               if ($import_dbimptype == 'SAVE') {

                    $this->CORE_DB->sql_save(array('table'  => 'ecom_inventory', 'data'   => $invitem, 'where'  => 'id=' . $this->CORE_DB->quote($invitem['id']),'update' => '*'));

               } else {

                    $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_inventory', 'data'   => $invitem));

                    if (!($this->CORE->IsError($sql))) {$this->CORE_DB->sql_do(array('sql'   => $sql, 'table' => 'ecom_inventory'));}

               } // End of if statement.

          } // End of if statement.

          // +--
          // | New columns and data changes.
          // +--

          $row['acctsysalt']              = '';
          $row['acctsysaltmod']           = 0;
          $row['acctsysincome']           = 'income-service';
          $row['acctsyspri']              = '';
          $row['acctsysprimod']           = 0;
          $row['autogiftcert']            = 0;
          $row['beonly']                  = 0;
          $row['catfeatgrid']             = '';
          $row['catfeatgridname']         = '';
          $row['catfeatgridshow']         = 0;
          $row['catparent']               = '';
          $row['commok']                  = 1;
          $row['createdate']              = $row['datetimestamp'];
          $row['customdata']              = '';
          $row['custpkgdisp']             = 'SELECT';
          $row['xaddonsdisp']             = 'CHECKBOX';
          $row['descso']                  = '';
          $row['disallowdiscount']        = 0;
          $row['discexclusions']          = '';
          $row['grouplimits']             = '';
          $row['grouplimitstatus']        = 0;
          $row['imglgso']                 = '';
          $row['imgsmso']                 = '';
          $row['invitemmultdisp']         = 'SELECT';
          $row['manufacturer']            = 'DEFAULT';
          $row['multisitedescone']        = '';
          $row['multisitedesconelimit']   = '';
          $row['multisitedesctwo']        = '';
          $row['multisitedesctwolimit']   = '';
          $row['offertype']               = 'SERVOPTDL';
          $row['offergiftpromo']          = '0.00';
          $row['priceoverride']           = '';
          $row['pricingtype']             = 'REGONLY';
          $row['prodhighlights']          = '';
          $row['prodpdf']                 = '';
          $row['prodsectiondisp']         = '';
          $row['seoexact']                = 0;
          $row['servpriceinput']          = 0;
          $row['servreq']                 = 0;
          $row['showpriceincartonly']     = 0;
          $row['specialofferforcereg']    = 0;
          $row['specialofferforcewhl']    = 0;
          $row['specialofferreg']         = 0;
          $row['specialofferwhl']         = 0;
          $row['videourl']                = '';
          $row['xaddons']                 = '';
          $row['xcatparent']              = '';
          $row['xmultisite']              = '';
          $row['xpricemap']               = 'DEFAULT-' . $row['id'] . '-DEFAULT-' . $row['id'];

          $row['name'] = preg_replace('//','"',$row['name']);
          $row['name'] = preg_replace('//','"',$row['name']);
          $row['name'] = preg_replace('/\&\#.*\;/','',$row['name']);

          if     (!(empty($invitemid)))       {$row['offertype'] = 'INVITEMS';}
          elseif ($row['pricestatus'] == 'D') {$row['offertype'] = 'NOTFORSALE';}

          if (($row['offertype'] == 'SERVOPTDL') && (preg_match('/gift/i',$row['name']))) {$row['autogiftcert'] = 1;}

          if (!(empty($row['xcat']))) {

               $xcat = $this->CORE->make_list($row['xcat']);
               $xcat = array_reverse($xcat);

               $row['catparent'] = $xcat[0];

          } // End of if statement.

          if (!(empty($row['splashdisp'])))   {if (!(empty($row['prodsectiondisp']))) {$row['prodsectiondisp'] .= ', ';} $row['prodsectiondisp'] .= 'SPLASH';}
          if (!(empty($row['featuredisp1']))) {if (!(empty($row['prodsectiondisp']))) {$row['prodsectiondisp'] .= ', ';} $row['prodsectiondisp'] .= 'FEAT1';}
          if (!(empty($row['featuredisp2']))) {if (!(empty($row['prodsectiondisp']))) {$row['prodsectiondisp'] .= ', ';} $row['prodsectiondisp'] .= 'FEAT2';}
          if (!(empty($row['featuredisp3']))) {if (!(empty($row['prodsectiondisp']))) {$row['prodsectiondisp'] .= ', ';} $row['prodsectiondisp'] .= 'FEAT3';}
          if (!(empty($row['featuredisp4']))) {if (!(empty($row['prodsectiondisp']))) {$row['prodsectiondisp'] .= ', ';} $row['prodsectiondisp'] .= 'FEAT4';}
          if (!(empty($row['featuredisp5']))) {if (!(empty($row['prodsectiondisp']))) {$row['prodsectiondisp'] .= ', ';} $row['prodsectiondisp'] .= 'FEAT5';}

          // +--
          // | Build pricemap entry (while we still have pricing fields in memory)
          // +--

          if ($row['offertype'] != 'NOTFORSALE') {

               $pm = array();

               $regprice  = '0.00';
               $compprice = '0.00';
               $whlprice  = $row['whlprice'];

               if ($row['pricestatus'] == 'S') {$compprice = $row['regprice']; $regprice = $row['saleprice'];}
               else                            {$regprice = $row['regprice'];}

               if ($whlprice <= 0) {$whlprice = $regprice;}

               $pm['id']                = 'DEFAULT-' . $row['id'] . '-DEFAULT-' . $row['id'];
               $pm['channelid']         = 'DEFAULT';
               $pm['xofferid']          = $row['id'];
               $pm['maptype']           = 'DEFAULT';
               $pm['xinvid']            = $invitemid;
               $pm['groupname']         = 'DEFAULT';
               $pm['quantity']          = 1;
               $pm['sortorder']         = 10;
               $pm['regprice']          = sprintf("%.2f",round($regprice,2));
               $pm['whlprice']          = sprintf("%.2f",round($whlprice,2));
               $pm['compprice']         = sprintf("%.2f",round($compprice,2));
               $pm['recurprice']        = '0.00';
               $pm['loyaltypoints']     = $row['loyaltypoints'];
               $pm['rebate']            = '0.00';
               $pm['cost']              = '0.00';
               $pm['taxclass']          = 'STANDARD';
               $pm['taxstateprov']      = 'STANDARD';
               $pm['taxcountry']        = 'STANDARD';
               $pm['datetimestamp']     = $row['datetimestamp'];
               $pm['cacheoffername']    = $row['name'];
               $pm['cacheinvname']      = $row['name'];
               $pm['cachemanuname']     = 'Default Manufacturer';

               if ($row['pricestatus'] == 'V') {

                    $pm['regprice'] = $row['volprice'];
                    $pm['whlprice'] = $row['volprice'];

               } // End of if statement.

               if ($row['offertype'] == 'SERVOPTDL') {

                    $pm['taxstateprov']  = 'EXEMPT';
                    $pm['taxcountry']    = 'EXEMPT';
                    $pm['cacheinvname']  = '';

               } // End of if statement.

               if ($import_dbimptype == 'SAVE') {
     
                    $this->CORE_DB->sql_save(array('table'  => 'ecom_pricemap', 'data'   => $pm, 'where'  => 'id=' . $this->CORE_DB->quote($pm['id']),'update' => '*'));

               } else {

                    $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_pricemap', 'data'   => $pm));

                    if (!($this->CORE->IsError($sql))) {$this->CORE_DB->sql_do(array('sql'   => $sql, 'table' => 'ecom_pricemap'));}

               } // End of if statement.

          } // End of if statement.

          // +--
          // | Delete old, unused columns.
          // +--

          unset($row['affilcomm']);
          unset($row['bestselldisp']);
          unset($row['customship']);
          unset($row['datetimestamp']);
          unset($row['delmethod']);
          unset($row['descmobile']);
          unset($row['featuredisp1']);
          unset($row['featuredisp2']);
          unset($row['featuredisp3']);
          unset($row['featuredisp4']);
          unset($row['featuredisp5']);
          unset($row['imgxl']);
          unset($row['invlevel']);
          unset($row['lgdisp']);
          unset($row['loyaltypoints']);
          unset($row['maxquan']);
          unset($row['minquan']);
          unset($row['newdisp']);
          unset($row['notifystock']);
          unset($row['pricestatus']);
          unset($row['prodidx']);
          unset($row['prodmulti']);
          unset($row['recurprice']);
          unset($row['regprice']);
          unset($row['reviewsavg']);
          unset($row['reviewsnum']);
          unset($row['saleprice']);
          unset($row['shipcountry']);
          unset($row['shipemail']);
          unset($row['shipheight']);
          unset($row['shipint']);
          unset($row['shiplength']);
          unset($row['shiplocal']);
          unset($row['shipnumbox']);
          unset($row['shiponename']);
          unset($row['shiponeprice']);
          unset($row['shipstateprov']);
          unset($row['shipthreename']);
          unset($row['shipthreeprice']);
          unset($row['shiptwoname']);
          unset($row['shiptwoprice']);
          unset($row['shipweight']);
          unset($row['shipwidth']);
          unset($row['shipzip']);
          unset($row['specialsdisp']);
          unset($row['splashdisp']);
          unset($row['taxclass']);
          unset($row['taxcountry']);
          unset($row['taxstateprov']);
          unset($row['useinv']);
          unset($row['volprice']);
          unset($row['whlprice']);

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Orders();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Orders                                            |
// +------------------------------------------------------------------+

function step_Orders () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','10');
$this->CORE->globals('importer.steptext','Orders Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Orders';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'OrdersP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_OrdersP                                           |
// +------------------------------------------------------------------+

function step_OrdersP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Orders';
$table    = 'ecom_orders';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Discounts();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'OrdersP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $this->CORE_DB->sql_do(array('sql' => 'DELETE FROM ' . $table, 'table' => $table));

     $this->CORE_DB->sql_do(array('sql' => 'DELETE FROM ecom_orderitems', 'table' => 'ecom_orderitems'));

     $this->CORE_DB->sql_do(array('sql' => 'DELETE FROM ecom_payments', 'table' => 'ecom_payments'));

} // End of if statement.

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          if ($row['status'] == 'P' || $row['status'] == 'PCE' || $row['status'] == 'X') {continue;}

          // +--
          // | New columns and data changes.
          // +--

          $row['acctsysalt']              = 'RECORDED';
          $row['acctsysdata']             = '';
          $row['acctsyspri']              = 'RECORDED';
          $row['adjposdiscreturned']      = 0;
          $row['adjposgiftcerttotal']     = '';
          $row['channelcompleted']        = 0;
          $row['channelid']               = 'DEFAULT';
          $row['channelorderid']          = '';
          $row['comptotal']               = '0.00';
          $row['costtotal']               = '0.00';
          $row['credit']                  = '';
          $row['credittotal']             = '0.00';
          $row['currshow']                = '';
          $row['currconvrate']            = '';
          $row['custpaytotal']            = $row['ordertotal'];
          $row['custorderemails']         = '';
          $row['custponum']               = '';
          $row['epochcomplete']           = 1;
          $row['giftcert']                = '';
          $row['giftcerttotal']           = '0.00';
          $row['intorderemails']          = '';
	  $row['invoicemail']             = 0;
	  $row['invoicedisp']             = 0;
          $row['isspecoffer']             = 0;
          $row['iswholesale']             = 0;
          $row['iswholesalepremium']      = 0;
          $row['loyaltypointsearned']     = 0;
          $row['loyaltypointsredeemed']   = 0;
          $row['mktexported']             = '';
          $row['netreturntotal']          = '0.00';
          $row['ordadjustneg']            = '';
          $row['ordadjustnegtotal']       = '0.00';
          $row['ordadjustpos']            = '';
          $row['ordadjustpostotal']       = '0.00';
          $row['orderbalance']            = '0.00';
	  $row['ordemaillogosup']         = 0;
          $row['ordreviewinfo']           = '';
          $row['ordreviewstatus']         = 0;
          $row['payterms']                = '';
          $row['posordertype']            = '';
          $row['rebatetotal']             = '0.00';
          $row['returnordadjpostotal']    = '0.00';
          $row['returnshiptaxtotal']      = '0.00';
          $row['returnsurchargetotal']    = '0.00';
          $row['shipdisctotal']           = '0.00';
          $row['shippingmemo']            = '';
          $row['shiptotalactual']         = '0.00';
          $row['shiptotalmodified']       = 0;
          $row['shipwtaxdiscreturned']    = 0;
          $row['shipwtaxgiftcerttotal']   = '0.00';
          $row['sourceorder']             = '';
          $row['statuscompleted']         = 0;
          $row['statusenabled']           = 1;
          $row['statusinit']              = 1;
          $row['statusinvprocessed']      = 1;
          $row['statusreturnsproc']       = 0;
          $row['statusserviced']          = 1;
          $row['suppresscustemail']       = 0;
          $row['surchdiscreturned']       = 0;
          $row['surchgiftcerttotal']      = '0.00';
          $row['taxcrefshiptotal']        = '0.00';
          $row['taxcshiprate']            = '0.00';
          $row['taxcshiptotal']           = '0.00';
          $row['taxspshiprate']           = '0.00';
          $row['taxspshiptotal']          = '0.00';
          $row['xmultisite']              = 'DEFAULT';
          $row['taxcesttotal']            = '0.00';
          $row['taxcestreftotal']         = '0.00';
          $row['taxcestshiptotal']        = '0.00';
          $row['taxcestrefshiptotal']     = '0.00';
          $row['taxcestshiprate']         = '0.00';

          if ($row['status'] == 'C') {

               $row['epochcomplete']           = $row['epochorder'];
               $row['statuscompleted']         = 1;
               $row['statusenabled']           = 1;

          } // End of if statement.

          $ordtotals = array('adjposgiftcerttotal', 'commtotal', 'comptotal', 'costtotal', 'credittotal', 'custpaytotal', 'custsaletotal', 'custsurchargetotal', 'disctotal', 'giftcerttotal', 'loyaltypointstotal', 
                             'netreturntotal', 'ordadjustnegtotal', 'ordadjustpostotal', 'ordertotal', 'rebatetotal', 'recurtotal', 'returnordadjpostotal', 'returnshiptaxtotal', 'returnsurchargetotal', 
                             'shipdisctotal', 'shiptotal', 'shiptotalactual', 'shipwtaxgiftcerttotal', 'subtotal', 'surchgiftcerttotal', 'taxcrefshiptotal', 'taxcreftotal', 
                             'taxcshiptotal', 'taxctotal', 'taxspshiptotal', 'taxsptotal');

          foreach ($ordtotals as $tnum => $tid) {if (empty($row[$tid])) {$row[$tid] = 0;} $row[$tid] = sprintf("%.2f",round($row[$tid],2));}

          // +--
          // | Delete associated payments and order items.
          // +--

          if ($import_dbimptype != 'INSERTDELETE') {

               $sql  = 'DELETE FROM ecom_orderitems WHERE orderid=' . $this->CORE_DB->quote($row['id']);
               $this->CORE_DB->sql_do(array('sql' => $sql, 'table' => 'ecom_orderitems'));

               $sql  = 'DELETE FROM ecom_payments WHERE orderid=' . $this->CORE_DB->quote($row['id']);
               $this->CORE_DB->sql_do(array('sql' => $sql, 'table' => 'ecom_payments'));

          } // End of if statement.

          // +--
          // | Handle order items.
          // +--

          $sql  = 'SELECT * FROM ecom_orderitems WHERE orderid=' . $this->CORE_DBX->quote($row['id']);

          $xdata = $this->CORE_DBX->sql_do(array('sql' => $sql, 'table' => 'ecom_orderitems','order' => array('id'=>'ASC')));

          if (($this->CORE->IsError($xdata)) || (empty($xdata))) {continue;}

          foreach ($xdata as $xnum => $xrow) {

               $cartdata = array(); if (!(empty($xrow['cartdata']))) {$cartdata = unserialize($xrow['cartdata']); if (!(is_array($cartdata))) {$cartdata = array();}}

               // +--
               // | New columns and data changes.
               // +--

               $xrow['addemtext']             = '';
               $xrow['autogiftcert']          = 0;
               $xrow['autogiftcertsin']       = '';
               $xrow['barcode']               = '';
               $xrow['catparent']             = '';
               $xrow['channelitemid']         = '';
               $xrow['commtotal']             = '0.00';
               $xrow['comptotal']             = '0.00';
               $xrow['costtotal']             = '0.00';
               $xrow['customdata']            = '';
               $xrow['custsaletotal']         = '0.00';
               $xrow['discitemsreturned']     = 0;
               $xrow['disctotal']             = '0.00';
               $xrow['dlfilegets']            = 0;
               $xrow['dlfiles']               = '';
               $xrow['epochship']             = 1;
               $xrow['giftcertexpdate']       = '';
               $xrow['giftcertissued']        = '';
               $xrow['giftcertstartdate']     = '';
               $xrow['giftcerttotal']         = '0.00';
               $xrow['invcontrols']           = 0;
               $xrow['invlocal']              = 1;
               $xrow['invlocalshipmanager']   = 0;
               $xrow['itemnote']              = '';
               $xrow['loyaltypointsearned']   = 0;
               $xrow['loyaltypointsredeemed'] = 0;
               $xrow['loyaltypointstotal']    = '0.00';
               $xrow['manufacturer']          = 'DEFAULT';
               $xrow['netreturntotal']        = '0.00';
               $xrow['ordadjustnegtotal']     = '0.00';
               $xrow['phone']                 = $row['phone'];
               $xrow['promoname']             = '';
               $xrow['purchorditemsrec']      = 0;
               $xrow['purchorditemsreqid']    = '';
               $xrow['purchordsid']           = '';
               $xrow['rebatetotal']           = '0.00';
               $xrow['servstatus']            = 'N';
               $xrow['shipcountry']           = '';
               $xrow['shipmanager']           = '';
               $xrow['shipmanagerbatch']      = '';
               $xrow['shipmanagershipment']   = '';
               $xrow['shipstateprov']         = '';
               $xrow['shipweight']            = '0.000';
               $xrow['shipzip']               = '';
               $xrow['statuscompleted']       = 0;
               $xrow['statusreturned']        = 0;
               $xrow['statusserviced']        = 1;
               $xrow['subtotal']              = $xrow['ordertotal'];
               $xrow['taxcrate']              = '';
               $xrow['taxcreftotal']          = '0.00';
               $xrow['taxctotal']             = '0.00';
               $xrow['taxsprate']             = '0.00';
               $xrow['taxsptotal']            = '0.00';
               $xrow['tracknums']             = '';
               $xrow['tracknumtype']          = 'OTHER';
               $xrow['uploads']               = '';
               $xrow['vendorid']              = 'DEFAULT';
               $xrow['warehouseloc']          = 'A1';
               $xrow['xinvid']                = $xrow['itemid'];

               $xrow['cartdata']              = @serialize(array());

               if (!(empty($cartdata['addemtext'])))                     {$xrow['addemtext']          = $cartdata['addemtext'];}
               if (!(empty($cartdata['totalbasis']['taxstateprov'])))    {$xrow['taxsptotal']         = $cartdata['totalbasis']['taxstateprov'];}
               if (!(empty($cartdata['totalbasis']['taxcountry'])))      {$xrow['taxctotal']          = $cartdata['totalbasis']['taxcountry'];}
               if (!(empty($cartdata['totalbasis']['taxcountryref'])))   {$xrow['taxcreftotal']       = $cartdata['totalbasis']['taxcountryref'];}
               if (!(empty($cartdata['totalbasis']['customsale'])))      {$xrow['custsaletotal']      = $cartdata['totalbasis']['customsale'];}
               if (!(empty($cartdata['totalbasis']['loyaltypoints'])))   {$xrow['loyaltypointstotal'] = $cartdata['totalbasis']['loyaltypoints'];}
               if (!(empty($cartdata['totalbasis']['customsurcharge']))) {$xrow['custsurchargetotal'] = $cartdata['totalbasis']['customsurcharge'];}
               if (!(empty($cartdata['totalbasis']['discount'])))        {$xrow['disctotal']          = $cartdata['totalbasis']['discount'];}
               if (!(empty($cartdata['totalbasis']['giftcert'])))        {$xrow['giftcerttotal']      = $cartdata['totalbasis']['giftcert'];}
               if (!(empty($cartdata['sinshipinfo']['shipcountry'])))    {$xrow['shipcountry']        = $cartdata['sinshipinfo']['shipcountry'];}
               if (!(empty($cartdata['sinshipinfo']['shipzip'])))        {$xrow['shipzip']            = $cartdata['sinshipinfo']['shipzip'];}
               if (!(empty($cartdata['sinshipinfo']['shipweight'])))     {$xrow['shipweight']         = $cartdata['sinshipinfo']['shipweight'];}
               if (!(empty($cartdata['sinshipinfo']['shipstateprov'])))  {$xrow['shipstateprov']      = $cartdata['sinshipinfo']['shipstateprov'];}
               if (!(empty($cartdata['dlfiles'])))                       {$xrow['dlfiles']            = $cartdata['dlfiles'];}

               if (!(empty($row['statuscompleted']))) {$xrow['shipstatus'] = 'S';}

               if ($xrow['shipstatus'] == 'S') {

                    if     (!(empty($row['trackfedex'])))    {$xrow['tracknumtype'] = 'FEDEX';    $xrow['tracknums'] = $row['trackfedex'];}
                    elseif (!(empty($row['trackupstools']))) {$xrow['tracknumtype'] = 'UPSTOOLS'; $xrow['tracknums'] = $row['trackupstools'];}
                    elseif (!(empty($row['trackusps'])))     {$xrow['tracknumtype'] = 'USPS';     $xrow['tracknums'] = $row['trackusps'];}
                    elseif (!(empty($row['trackother'])))    {$xrow['tracknums']    = $row['trackother'];}

                    $xrow['statuscompleted'] = 1;
                    $xrow['epochship']       = $row['epochorder'];

                    $row['statusenabled']      = 1;
                    $row['statusinvprocessed'] = 1;

               } // End of if statement.

               $ordtotals = array('commtotal', 'comptotal', 'costtotal', 'custsaletotal', 'disctotal', 'giftcerttotal', 'loyaltypointstotal', 'netreturntotal', 'ordadjustnegtotal', 'rebatetotal', 
                                  'recurtotal', 'subtotal', 'taxcreftotal', 'taxctotal', 'taxsptotal');

               foreach ($ordtotals as $tnum => $tid) {$xrow[$tid] = sprintf("%.2f",round($xrow[$tid],2));}

               // +--
               // | Delete old, unused columns.
               // +--

               unset($xrow['loyaltypoints']);
               unset($xrow['ordertotal']);

               // +--
               // | Save order item
               // +--

               $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_orderitems', 'data'  => $xrow));

               if (!($this->CORE->IsError($sql))) {$this->CORE_DB->sql_do(array('sql' => $sql, 'table' => 'ecom_orderitems'));}

          } // End of foreach statement.

          // +--
          // | Insert payment for this order.
          // +--

          $payment = array('id'           => $row['id'] . '-' . @strtoupper($this->CORE->random_key(12)),
                           'email'        => $row['email'],
                           'orderid'      => $row['id'],
                           'orderidorig'  => '',
                           'creditid'     => '',
                           'paytype'      => 'PAYMENTAPPLIED',
                           'paydesc'      => 'Payment',
                           'payattrib'    => 'ORDER',
                           'payamount'    => $row['ordertotal'],
                           'paydate'      => $row['epochorder'],
                           'payref'       => '',
                           'paymethod'    => 'CREDITCARD',
                           'gatewayid'    => $row['paymethod'],
                           'proctransid'  => '',
                           'cctype'       => '',
                           'xmultisite'   => 'DEFAULT',
                           'acctsyspri'   => 'RECORDED',
                           'acctsysalt'   => 'RECORDED');

          if     (($row['paymethod'] == 'nopay') || ($row['paymethod'] == 'zerobal'))                                             {$payment['paymethod'] = 'OTHER';}
          elseif (($row['paymethod'] == 'check') || ($row['paymethod'] == 'authnetaimck') || ($row['paymethod'] == 'wellsaimck')) {$payment['paymethod'] = 'CHECK';}
          elseif (($row['paymethod'] == 'paypalproe') || ($row['paymethod'] == 'paypalpp'))                                       {$payment['paymethod'] = 'PAYPAL';}

          $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_payments', 'data'  => $payment));

          if (!($this->CORE->IsError($sql))) {$this->CORE_DB->sql_do(array('sql' => $sql, 'table' => 'ecom_payments'));}

          // +--
          // | Delete old, unused columns.
          // +--

          unset($row['guest']);
          unset($row['postordaff']);
          unset($row['postorddisc']);
          unset($row['postordinv']);
          unset($row['postordloyaltypoints']);
          unset($row['postordloyaltypointspay']);
          unset($row['postordpt']);
          unset($row['postordqb']);
          unset($row['postordsage']);
          unset($row['trackfedex']);
          unset($row['trackupstools']);
          unset($row['trackusps']);

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Discounts();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Discounts                                         |
// +------------------------------------------------------------------+

function step_Discounts () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','11');
$this->CORE->globals('importer.steptext','Discount Code Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Discount Codes';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'DiscountsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DiscountsP                                        |
// +------------------------------------------------------------------+

function step_DiscountsP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Discount Codes';
$table    = 'ecom_discounts';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_HtmlPage();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'DiscountsP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $sql  = 'DELETE FROM ' . $table;

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => $table));

} // End of if statement.

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Bad character removal from id-related fields.
          // +--

          $col       = 'xprod';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = ''; foreach ($xdata as $xnum => $xid) {if (empty($xid)) {continue;} $row[$col] .= preg_replace('/[^a-zA-Z0-9\_\-]/','',$xid) . ', ';}
          $row[$col] = preg_replace('/\, $/','',$row[$col]);

          // +--
          // | New columns and data changes.
          // +--

          $row['acctsysalt']                = '';
          $row['acctsysaltmod']             = 0;
          $row['acctsysincome']             = 'income-discount';
          $row['acctsyspri']                = '';
          $row['acctsysprimod']             = 0;
          $row['applyorderinfo']            = '';
          $row['createdate']                = @time();
          $row['expdate']                   = '';
          $row['startdate']                 = '';
          $row['statushold']                = 0;
          $row['xmultisite']                = '';
          $row['excludeuseglobal']          = 0;
          $row['xmanu']                     = '';
          $row['excludeuseglobalmanu']      = 0;
          $row['excludespecoffer']          = 0;
          $row['excludeuseglobalspecoffer'] = 0;
          $row['excludeoffers']             = 1;

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_HtmlPage();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_HtmlPage                                          |
// +------------------------------------------------------------------+

function step_HtmlPage () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','12');
$this->CORE->globals('importer.steptext','HTML Page Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'HTML Pages';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'HtmlPageP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_HtmlPageP                                         |
// +------------------------------------------------------------------+

function step_HtmlPageP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'HTML Pages';
$table    = 'cms_html';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_DynForm();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'HtmlPageP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $sql  = 'DELETE FROM ' . $table . ' WHERE id<>' . $this->CORE_DB->quote('splash') . ' AND ';
     $sql .= 'id<>' . $this->CORE_DB->quote('companyinfo') . ' AND ';
     $sql .= 'id<>' . $this->CORE_DB->quote('cookieinfo');

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => $table));

} // End of if statement.

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | New columns and data changes.
          // +--

          $row['seoexact']    = 0;
          $row['xmultisite']  = '';

          $row['htmlcontent'] = preg_replace('/\<h2.*?\>/si','<h2>',$row['htmlcontent']);
          $row['htmlcontent'] = preg_replace('/defaultinternalmenu/si','kmenu',$row['htmlcontent']);

          if ($row['id'] == 'splash') {$row['seourl'] = '{ROOT}';}

          // +--
          // | Delete old, unused columns.
          // +--

          unset($row['datetimestamp']);
          unset($row['mobilecontent']);

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if (($row['id'] == 'splash') || ($row['id'] == 'companyinfo') || ($row['id'] == 'cookieinfo') || ($import_dbimptype == 'SAVE')) {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_DynForm();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DynForm                                           |
// +------------------------------------------------------------------+

function step_DynForm () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','13');
$this->CORE->globals('importer.steptext','Dynamic Form Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Dynamic Forms';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'DynFormP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DynFormP                                          |
// +------------------------------------------------------------------+

function step_DynFormP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Dynamic Forms';
$table    = 'cms_dynforms';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_DynFormFld();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'DynFormP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $sql  = 'DELETE FROM ' . $table;

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => $table));

} // End of if statement.

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_DynFormFld();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DynFormFld                                        |
// +------------------------------------------------------------------+

function step_DynFormFld () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','14');
$this->CORE->globals('importer.steptext','Dynamic Form Field Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Dynamic Form Fields';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'DynFormFldP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DynFormFldP                                       |
// +------------------------------------------------------------------+

function step_DynFormFldP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Dynamic Form Fields';
$table    = 'cms_dynformfields';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Banners();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'DynFormFldP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $sql  = 'DELETE FROM ' . $table;

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => $table));

} // End of if statement.

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Banners();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Banners                                           |
// +------------------------------------------------------------------+

function step_Banners () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','15');
$this->CORE->globals('importer.steptext','Banner Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Banners';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'BannersP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_BannersP                                          |
// +------------------------------------------------------------------+

function step_BannersP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Banners';
$table    = 'cms_banners';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Reviews();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'BannersP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $sql  = 'DELETE FROM cms_bannermain';

     $this->CORE_DB->sql_do(array('sql' => $sql, 'table' => 'cms_bannermain'));

     $sql  = 'DELETE FROM cms_banneradverts';

     $this->CORE_DB->sql_do(array('sql' => $sql, 'table' => 'cms_banneradverts'));

} // End of if statement.

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | New columns and data changes.
          // +--
 
          $row['xmultisite']         = '';
          $row['linkanchor']         = '';
          $row['bannermid']          = $row['bannerimg'];

          if ($row['placement'] == 'CONTENT') {

               $thistable = 'cms_bannermain';

               $row['bannerthin'] = '';
               $row['bannerwide'] = '';

               $filesrc  = $this->CORE->globals('importer.import_path_public') . '/media/cms/banners/' . $row['bannermid'];
               $filedest = $this->CORE->globals('core.path_public') . '/media/cms/bannermainmid/' . $row['bannermid'];

               if     (!(@file_exists($filesrc)))  {continue;}
               elseif (!(@file_exists($filedest))) {$this->CORE_File->copy(array('source' => $filesrc, 'dest' => $filedest));}

          } else {

               $row['mainbannersupgroup'] = '';

               $thistable = 'cms_banneradverts';

               $filesrc  = $this->CORE->globals('importer.import_path_public') . '/media/cms/banners/' . $row['bannermid'];
               $filedest = $this->CORE->globals('core.path_public') . '/media/cms/banneralt/' . $row['bannermid'];

               if     (!(@file_exists($filesrc)))  {continue;}
               elseif (!(@file_exists($filedest))) {$this->CORE_File->copy(array('source' => $filesrc, 'dest' => $filedest));}

          } // End of if statement.

          // +--
          // | Delete old, unused columns.
          // +--

          unset($row['bannerimg']);
          unset($row['placement']);

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $thistable,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $thistable,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $thistable));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Reviews();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Reviews                                           |
// +------------------------------------------------------------------+

function step_Reviews () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','16');
$this->CORE->globals('importer.steptext','Reviews Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Reviews';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.',
                               'INSERTDELETE' => 'Delete all data, then insert new data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'ReviewsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ReviewsP                                          |
// +------------------------------------------------------------------+

function step_ReviewsP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Reviews';
$table    = 'ecom_reviews';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_CustSale();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'ReviewsP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Delete data if requested.
// +--

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete)) && ($offset == 0) && ($import_dbimptype == 'INSERTDELETE')) {

     $sql  = 'DELETE FROM ' . $table;

     $this->CORE_DB->sql_do(array('sql'   => $sql,
                                  'table' => $table));

} // End of if statement.

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Bad character removal from id-related fields.
          // +--

          $row['prodid'] = preg_replace('/[^a-zA-Z0-9\_\-]/','',$row['prodid']);

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_CustSale();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustSale                                          |
// +------------------------------------------------------------------+

function step_CustSale () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','17');
$this->CORE->globals('importer.steptext','Custom Sale Script Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Custom Sale Scripts';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'CustSaleP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustSaleP                                         |
// +------------------------------------------------------------------+

function step_CustSaleP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Custom Sale Scripts';
$table    = 'ecom_salecust';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_CustShip();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'CustSaleP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_CustShip();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustShip                                          |
// +------------------------------------------------------------------+

function step_CustShip () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','18');
$this->CORE->globals('importer.steptext','Custom Shipping Script Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Custom Shipping Scripts';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'CustShipP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustShipP                                         |
// +------------------------------------------------------------------+

function step_CustShipP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Custom Shipping Scripts';
$table    = 'ecom_shipcust';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_CustSurch();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'CustShipP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_CustSurch();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustSurch                                         |
// +------------------------------------------------------------------+

function step_CustSurch () {

// +--
// | Importer Function Step
// +--

$this->CORE->globals('importer.step','19');
$this->CORE->globals('importer.steptext','Custom Surcharge Script Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');
$this->CORE->globals('core_cgi.import_dbimptype','INSERTONLY');

$software = $this->CORE->globals('importer.name');
$stepdesc = 'Custom Surcharge Scripts';

$header  = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$header .= $software . ' installation.</p>';

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = $stepdesc . ' Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import ' . strtolower($stepdesc) . '.');

$fields[0]['desc']     = '<p>Indicate below whether you would like to import ' . strtolower($stepdesc) . ' from your ';
$fields[0]['desc']    .= $software . ' installation.  You have the option to skip this step.</p>';

$fields[1]['id']       = 'import_dbimptype';
$fields[1]['name']     = 'Database Import Type';
$fields[1]['type']     = 'RADIO';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('INSERTONLY'   => 'Insert new data only.',
                               'SAVE'         => 'Insert new data, and update existing data.');

$fields[1]['desc']     = '<p>Indicate below the type of import you would like to perform.</p>';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'CustSurchP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustSurchP                                        |
// +------------------------------------------------------------------+

function step_CustSurchP () {

// +--
// | Importer Function Step
// +--

$stepdesc = 'Custom Surcharge Scripts';
$table    = 'ecom_surchargecust';

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message  = 'Thank you. You selected to skip importing ' . strtolower($stepdesc) . '.  ';
     $message .= 'No ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Final();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($table);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'CustSurchP';
$mtinfo['currtask']   = $stepdesc . ' Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($table,$offset,$count);

// +--
// | Loop through the data.
// +--

if ((!($this->CORE->IsError($data))) && (!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Save or insert, depending upon the import_dbimptype requested.
          // +--

          if ($import_dbimptype == 'SAVE') {

               $this->CORE_DB->sql_save(array('table'  => $table,
                                              'data'   => $row,
                                              'where'  => 'id=' . $this->CORE_DB->quote($row['id']),
                                              'update' => '*'));

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => $table,
                                                          'data'  => $row));

               if (!($this->CORE->IsError($sql))) {

                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => $table));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message  = 'Thank you. All ' . strtolower($stepdesc) . ' have been imported.';

     $this->disp_message($message,'CONFIRM');

     return $this->step_Final();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Final                                             |
// +------------------------------------------------------------------+

function step_Final () {

// +--
// | Importer Function Step.
// +--

// +--
// | Define variables for the confirm display.
// +--

$link     = $this->CORE->globals('core.script_backend');

// +--
// | Final Confirm Display
// +--

print <<<ENDOFTEXT

<p>The data import process has completed.  The data you chose to import 
has been saved to the primary database connection and the 
filesystem used by this software.</p>

<p><a href="{$link}" title="Management Interface">Click here to run 
the Management Interface.</a></p>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Display                                                 |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: disp                                                   |
// +------------------------------------------------------------------+

function disp () {

// +--
// | This function displays the importer screen output.
// +--

// +--
// | Define our date for our copyright and our EOL.
// +--

$eol       = $this->CORE->globals('core.eol');

$title_add = '';

if ($this->CORE->globals('importer.steptext')) {

     $title_add = ' - ' . $this->CORE->xhtml_translate($this->CORE->globals('importer.steptext'),'ENCODE');

} // End of if statement.

// +--
// | Print the header section.
// +--

print <<<ENDOFTEXT

<!DOCTYPE html>

<html lang="en">

<head>

<meta name="viewport" content="width=device-width, initial-scale=1" />

<link rel="preconnect" href="https://fonts.googleapis.com" />
<link rel="preconnect" href="https://fonts.gstatic.com" crossorigin />
<link href="https://fonts.googleapis.com/css2?family=Roboto:wght@400;700&display=swap" rel="stylesheet" />

<style media="all">
body {color: #000000; background-color: #FFFFFF; font-weight: normal; text-align: left; margin: 0; padding: 0; font-family: 'Roboto', Arial, Helvetica, sans-serif; font-size: 14px;}
a {color: #0089DA; text-decoration: none;}
a:hover {text-decoration: underline;}
#kcontentwrap {margin: 0 auto 2em auto; width: 50em; max-width: 90%;}
#kheader {padding: 1em; margin-bottom: 1em; background-color: #0089DA;}
#kcontent {padding: 1em;}
.khidden {display: none;}
.kwrap {line-height: 1.5;}
.kwrap h1 {font-size: 2em; font-weight: normal; margin: 0 0 .5em 0; color: #000000;}
.kwrap p {padding: 0; margin: 0 0 .75em 0; font-size: .9em;}
.kwrap p:last-child {margin-bottom: 0;}
.kwrap li {font-size: .9em;}
.kwrap form {margin: 0;}
.kwrap input[type="checkbox"], .kwrap input[type="radio"] {margin: 0;}
.kwrap input[type="text"], .kwrap input[type="password"], .kwrap select, .kwrap textarea {box-sizing: border-box; padding: .5em; margin: 0 .5em .5em 0; background-color: #FFFFFF; border: 1px solid #454851; font-size: .9em;}
.kwrap input[type="text"], .kwrap input[type="password"] {width: 16em; max-width: 90%;}
.kwrap textarea {width: 90%;}
.kwrap select {max-width: 90%;}
.kwrap input.krnc[type="text"], .kwrap input.krnc[type="password"], .kwrap select.krnc, .kwrap textarea.krnc {color: #000000; background-color: #FAC0C2; border: 1px solid #E50000;}
.kwrap input[type="text"]:focus, .kwrap input[type="password"]:focus, .kwrap select:focus, .kwrap textarea:focus {background-color: #FFFFDD; border: 1px solid #FFCC66;}
.kwrap input[type="submit"], .kwrap input[type="reset"] {font-size: 1.25em; cursor: pointer; border: 0; box-sizing: border-box; padding: .5em; line-height: 1 !important; color: #FFFFFF; background-color: #0089DA; margin: 1.5em .5em .5em 0;}
.kwrap input[type="submit"]:hover, .kwrap input[type="reset"]:hover {display: inline-block; background-color: #000000;}
.kwrap *:focus {outline: 0;}
.kbig {font-size: 1.2em;}
.kmid {font-size: .9em;}
.kstrong {font-weight: bold;}
.kimgstretch {display: block; width: 100%; height: auto; margin: 0 auto 0 auto; padding: 0;}
.kimgnice {display: block; margin: 0; width: auto; max-width: 100%; height: auto; padding: 0;}
.kimgnicecenter {display: block; margin: 0 auto 0 auto; width: auto; max-width: 100%; height: auto; padding: 0;}
.kbotmarginqtr {margin-bottom: .25em !important;}
.kbotmarginfull {margin-bottom: 1em !important;}
.kbotmarginhalf {margin-bottom: .5em !important;}
.kbotmarginnone {margin-bottom: 0 !important;}
.ktopmargindbl {margin-top: 1.5em !important;}
.klineheightreset {line-height: 1;}
.kerror, .kconfirm, .kcontainer {margin: 0 0 1em 0;}
.kerror {color: #E50000; font-weight: bold;}
.kconfirm {color: #2A802A; font-weight: bold;}
.kmimeter     {width: auto; margin: 0 0 1em 0;}
.kmimeterinfo {display: inline;}
.kmimetercomp {background-color: #2A802A; color: #2A802A; display: inline; font-weight: bold; padding: .25em 0 .25em 0;}
.kmimeterpend {background-color: #DEDEDE; color: #DEDEDE; display: inline; font-weight: bold; padding: .25em 0 .25em 0;}
.kmirrorthead {color: #000000; padding: 0; font-size: 1.5em; margin: 1.25em 0 .25em 0; font-weight: normal;}
.kmirrortrow {padding: 0; background-color: #F4F4F4; padding: 1em; border: 1px solid #DEDEDE;}
.kmirrortrow p {font-size: .8em;}
</style>

<title>Kryptronic Importer{$title_add}</title>

<script src="//central.kryptronic.com/public/jquery/jquery.min.js"></script>
<script>jQuery.noConflict();</script>

<script>

jQuery(function(){

ENDOFTEXT;

if ($this->CORE->globals('importer.auto_submit')) {print '     jQuery(\'#importer\').submit();' . $eol;}

print <<<ENDOFTEXT

     jQuery('a[rel=\'external\']').prop('target', '_blank');

});

</script>

</head>

<body>

<div id="kheader"><img src="//central.kryptronic.com/public/media/header_kryptronic.png" class="kimgnicecenter" alt="Kryptronic" /></div>

<div id="kcontentwrap">

<div id="kcontent" class="kwrap">

ENDOFTEXT;

// +--
// | Print the page header section.
// +--

$step     = $this->CORE->xhtml_translate($this->CORE->globals('importer.step'),'ENCODE');
$steptext = $this->CORE->xhtml_translate($this->CORE->globals('importer.steptext'),'ENCODE');
$numsteps = $this->CORE->xhtml_translate($this->CORE->globals('importer.numsteps'),'ENCODE');

if (($step) && ($steptext)) {

     print '<h1>Step ' . $step . ' of ';
     print $numsteps . ': ' . $steptext . '</h1>' . $eol . $eol;

} else {

     print '<h1>Kryptronic Importer: ';
     print $this->CORE->xhtml_translate($this->CORE->globals('importer.name'),'ENCODE');
     print '</h1>' . $eol . $eol;

} // End of if statement.

// +--
// | Print our content.
// +--

$content = $this->CORE->globals('importer.buffered_output');

print $content;

// +--
// | Print the page footer.
// +--

print <<<ENDOFTEXT

</div></div>

</body>

</html>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: disp_message                                           |
// +------------------------------------------------------------------+

function disp_message ($message = '',$type = 'ERROR') {

// +--
// | This function prints a message.
// +--

$eol = $this->CORE->globals('core.eol');

// +--
// | If message is blank, return true without printing anything.
// +--

if ($message == '') {return 1;}

// +--
// | Replace full directory paths in the message.
// +--

$pathpriv_quoted = preg_quote($this->CORE->globals('core.path_private'),'/');
$pathpub_quoted  = preg_quote($this->CORE->globals('core.path_public'),'/');

$message = preg_replace('/' . $pathpriv_quoted . '\//','/',$message);
$message = preg_replace('/' . $pathpub_quoted  . '\//','/',$message);

// +--
// | Encode the message.
// +--

$message = $this->CORE->xhtml_translate($message,'ENCODE');

// +--
// | Print the message.
// +--

if ($type == 'ERROR') {

     print '<div class="kerror">' . $message . '</div>' . $eol . $eol;

} else {

     print '<div class="kconfirm">' . $message . '</div>' . $eol . $eol;

} // End of if statement.

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: formdata_array                                         |
// +------------------------------------------------------------------+

function formdata_array ($input = array()) {

// +--
// | This function returns an array of formdata values.  It accepts
// | input in an array with the following format:
// |
// | key:   The formdata field.
// | value: Boolean indicating required status.
// |
// | This function will return an error object if any required fields
// | are not complete.
// +--

$result = array();

if (empty($input)) {return $result;}

$reqnotcomp = 0;

foreach ($input as $key => $value) {

     $xvalue = $this->CORE->globals('core_cgi.' . $key);

     if (!(isset($xvalue))) {$xvalue = '';}

     $result[$key] = $xvalue;

     if ((empty($result[$key])) && (!(empty($value)))) {$reqnotcomp++;}

} // End of foreach statement.

if ($reqnotcomp) {

     $message = "You did not complete all of the required fields before 
                 clicking the 'Continue' button.  Please try again.";

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Return the result array.
// +--

return $result;

} // End of function.

// +------------------------------------------------------------------+
// | Function: disp_form                                              |
// +------------------------------------------------------------------+

function disp_form ($input = array()) {

// +--
// | This function prints an XHTML form to be used by the importer.
// | 
// | Input is accepted in the form of an array with the following
// | parameters:
// |
// | 'header'   => XHTML header
// |
// | 'step'     => The step to post to.
// |
// | 'supform'  => Optional boolean indicator.  If true the opening 
// |               <form> tag is supressed.  Useful if the header
// |               contains form fields.
// |
// | 'autosub'  => Optional indicator.  If value is 1 this form 
// |               will be auto-submitted.
// |
// | 'fields'   => An array of fields with the following array keys:
// |
// |               'id'       => Form field name.
// |
// |               'name'     => Field display name.
// |
// |               'type'     => Form field type (SELECT, RADIO, HIDDEN
// |                           CHECKBOX, TEXT-REG, TEXT-LONG, PASSWORD)
// |
// |               'desc'     => Pre-formatted XHTML description.
// |
// |               'values'   => An array of values (key = select value,
// |                             value = select display name) for a 
// |                             SELECT, CHECKBOX or RADIO field.
// |
// |               'value'    => A value to use for HIDDEN fields.
// |
// |               'required' => Boolean required indicator.
// +--

$eol = $this->CORE->globals('core.eol');

// +--
// | Set up function variables.
// +--

$header  = (isset($input['header'])  ? $input['header']  : '');
$fields  = (isset($input['fields'])  ? $input['fields']  : array());
$step    = (isset($input['step'])    ? $input['step']    : 'Default');
$supform = (isset($input['supform']) ? $input['supform'] : 0);
$autosub = (isset($input['autosub']) ? $input['autosub'] : 0);

// +--
// | Handle the auto-submit form object.
// +--

if ($autosub == 1) {

     $this->CORE->globals('importer.auto_submit',1);

} // End of if statement.

// +--
// | Print the form header.
// +--

if ($header) {

     print $header . $eol . $eol;

} // End of if statement.

// +--
// | Print the <form> element and required info if not supressed.
// +--

if (empty($supform)) {

     $insname = $this->CORE->globals('importer.script_name');

     print '<form action="' . $insname . '" method="post" id="importer">' . $eol . $eol;

} // End of if statement.

// +--
// | Get a list of all of the fields.
// +--

$seen = array();

foreach ($fields as $num => $field) {

     $id = (isset($field['id']) ? $field['id'] : '');

     $seen[$id] = 1;

} // End of foreach statement.

// +--
// | Print the HIDDEN form fields.
// +--

foreach ($fields as $num => $field) {

     $id       = (isset($field['id'])       ? $field['id']       : '');
     $name     = (isset($field['name'])     ? $field['name']     : '');
     $type     = (isset($field['type'])     ? $field['type']     : '');
     $desc     = (isset($field['desc'])     ? $field['desc']     : '');
     $values   = (isset($field['values'])   ? $field['values']   : array());
     $value    = (isset($field['value'])    ? $field['value']    : '');
     $required = (isset($field['required']) ? $field['required'] : '');

     if ($type == 'HIDDEN') {

          $pid    = $this->CORE->xhtml_translate($id,'ENCODE');
          $pvalue = $this->CORE->xhtml_translate($value,'ENCODE');

          print '<input type="hidden" name="' . $pid . '" id="' . $pid . '" value="' . $pvalue . '" />' . $eol . $eol;

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print the ALL OTHER form fields.
// +--

foreach ($fields as $num => $field) {

     $id       = (isset($field['id'])       ? $field['id']       : '');
     $name     = (isset($field['name'])     ? $field['name']     : '');
     $type     = (isset($field['type'])     ? $field['type']     : '');
     $desc     = (isset($field['desc'])     ? $field['desc']     : '');
     $values   = (isset($field['values'])   ? $field['values']   : array());
     $value    = (isset($field['value'])    ? $field['value']    : '');
     $required = (isset($field['required']) ? $field['required'] : '');

     $req = ''; if ($required) {$req = '*';}

     $pvalue = $this->CORE->globals('core_cgi.' . $id); if (empty($pvalue)) {$pvalue = '';}

     $pid    = $this->CORE->xhtml_translate($id,'ENCODE');
     $pname  = $this->CORE->xhtml_translate($name,'ENCODE');

     $xpid   = $pid;

     if (($type == 'CHECKBOX') || ($xpid == 'RADIO')) {$xpid .= '--1';}

     if ($type != 'HIDDEN') {

          print '<div class="kmirrorthead">' . $pname . $req . '</div>' . $eol . $eol;

          print '<div class="kbotmarginfull kmirrortrow"><div class="kbotmarginfull">' . $desc . '</div>' . $eol . $eol;

          if (($type == 'TEXT-REG') || ($type == 'TEXT-LONG') || ($type == 'PASSWORD')) {

               $pvalue = $this->CORE->xhtml_translate($pvalue,'ENCODE');

               $size  = '25';   if ($type == 'TEXT-LONG')  {$size = '50';}
               $xtype = 'text'; if ($type == 'PASSWORD')   {$xtype = 'password';}

               print '<input type="' . $xtype . '" title="' . $pname . '"';

               if ($type == 'PASSWORD') {print 'autocomplete="off" ';}

               print 'name="' . $pid . '" id="' . $pid . '" value="';
               print $pvalue . '" size="' . $size . '" />' . $eol . $eol;

          } else {

               if (is_array($pvalue)) {$pvalue = array_flip($pvalue);} else {$pvalue = array($pvalue => 1);}

               if (!(empty($values))) {

                    $count   = 0;
                    $pvalues = array();

                    $made_checked = 0;

                    foreach ($values as $xkey => $xvalue) {

                         $count++;

                         $checked = 0; if (array_key_exists($xkey,$pvalue)) {$checked = 1; $made_checked = 1;}

                         $pvalues[] = array('value'   => $xkey,
                                            'display' => $this->CORE->xhtml_translate($xvalue,'ENCODE'),
                                            'checked' => $checked,
                                            'xid'     => $id . '--' . $count);

                    } // End of foreach statement.

                    if ((!($made_checked)) && ($type == 'RADIO')) {$pvalues[0]['checked'] = 1;}

                    if ($type == 'SELECT') {

                          print '<select name="' . $pid . '" id="' . $pid . '" title="' . $pname . '">' . $eol;

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' selected="selected"';}

                               print '<option value="' . $xv['value'] . '" ';
                               print $checked . '>' . $xv['display'] . '</option>' . $eol;

                          } // End of foreach statement.

                          print '</select>' . $eol . $eol;

                    } elseif ($type == 'CHECKBOX') {

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' checked="checked"';}

                               print '<div class="kbotmarginhalf klineheightreset kmid"><input type="checkbox" name="' . $pid . '[]" ';
                               print 'id="' . $xv['xid'] . '" value="' . $xv['value'] . '" title="' . $xv['value'] . '"';
                               print $checked . ' />' . ' ' . $xv['display'] . '</div>' . $eol;

                          } // End of foreach statement.

                    } elseif ($type == 'RADIO') {

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' checked="checked"';}

                               print '<div class="kbotmarginhalf klineheightreset kmid"><input type="radio" name="' . $pid . '" ';
                               print 'id="' . $xv['xid'] . '" value="' . $xv['value'] . '" title="' . $xv['value'] . '"';
                               print $checked . ' />' . ' ' . $xv['display'] . '</div>' . $eol;

                          } // End of foreach statement.

                    } // End of if statement.

               } // End of if statement.

          } // End of if statement.

          print '</div>' . $eol;

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print our license_agree, import_password and step fields
// | as well as other fields specific to this importer - if 
// | they weren't seen.
// +--

if (!(array_key_exists('license_agree',$seen))) {

     $value = $this->CORE->globals('core_cgi.license_agree');

     if (is_array($value)) {$value = 1;}

     $value = $this->CORE->xhtml_translate($value,'ENCODE');

     print '<input type="hidden" name="license_agree" id="license_agree" value="' . $value . '" />' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_password',$seen))) {

     $value = $this->CORE->xhtml_translate($this->CORE->globals('core_cgi.import_password'),'ENCODE');

     print '<input type="hidden" name="import_password" id="import_password" value="' . $value . '" />' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('step',$seen))) {

     print '<input type="hidden" name="step" id="step" value="' . $step . '" />' . $eol . $eol;

} // End of if statement.

if (($autosub == 1) && (!(array_key_exists('auto_submit',$seen)))) {

     print '<input type="hidden" name="auto_submit" id="auto_submit" value="1" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_pubconfig',$seen))) {

     $import_pubconfig = $this->CORE->globals('core_cgi.import_pubconfig');
     if (empty($import_pubconfig)) {$import_pubconfig = '';}
     
     print '<input type="hidden" name="import_pubconfig" id="import_pubconfig" value="' . $import_pubconfig . '" />' . $eol . $eol;

} // End of if statement.

// +--
// | Print the form footer.
// +--

print <<<ENDOFTEXT

<div class="kbotmarginfull"><input type="submit" name="SUBMIT" id="SUBMIT" value="Continue Import" /></div>

</form>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Multi-Task Form Display                                          |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: do_multitask                                           |
// +------------------------------------------------------------------+

function do_multitask ($multitask = array()) {

// +--
// | This function presents a multi-task form.
// +--

$eol = $this->CORE->globals('core.eol');

// +--
// | Define our current task.
// +--

$current_task_text = $this->CORE->xhtml_translate($multitask['currtask'],'ENCODE');

// +--
// | Set up the progress bar.
// +--

$progress_bar = '';

$progress_bar_countt  = $multitask['ntaskcount'];
$progress_bar_counti  = $multitask['ntaskcurr'];
$progress_bar_disp    = 50;

$bars_disp= '';
$bars_leftdisp = '';
$bar_count= 0;

$pct = $progress_bar_counti / $progress_bar_countt;
$pct = round($pct,2);

$pct_disp = $pct * 100;

$bars = $progress_bar_disp * $pct;
$bars = round($bars);

while ($bar_count < $bars) {$bar_count++; $bars_disp .= '|';}

$bars_left = $progress_bar_disp - $bars;

$bar_count = 0;

while ($bar_count < $bars_left) {$bar_count++; $bars_leftdisp .= '|';}

$pct_leftdisp = 100 - $pct_disp;

$progress_bar  = '';

if ($bars) {$progress_bar .= '<div class="kmimetercomp">' . $bars_disp . '</div>';}

if ($bars_left) {$progress_bar .= '<div class="kmimeterpend">' . $bars_leftdisp . '</div>';}

$progress_bar .= '<div class="kmimeterinfo"> [' . $pct_disp . '%]</div>' . $eol . $eol;

$header = <<<ENDOFTEXT

<p>You have selected to process a multi-task operation.  If this page does 
not automatically refresh itself within one second, click the 'Continue' 
button to proceed.</p>

ENDOFTEXT;

$insname = $this->CORE->globals('importer.script_name');

$header .= '<form action="' . $insname . '" method="post" id="importer">' . $eol . $eol;

$header .= <<<ENDOFTEXT

<div class="kmirrorthead">Task Status</div>

<div class="kmirrortrow kbotmarginfull">

<p>The progress meter below displays your progress during this multi-task operation.</p>

<div id='meter'>{$progress_bar}</div>

</div>

<input type="hidden" name="taskstatus" id="taskstatus" value="1" />

<div class="kmirrorthead">Current Task</div>

<div class="kmirrortrow kbotmarginfull">

<p class="kstrong">Current Task:</p>

<p>{$current_task_text}</p>

</div>

<input type="hidden" name="currenttask" id="currenttask" value="1" />

ENDOFTEXT;

// +--
// | Formulate the form fields.
// +--

$count = 0;

$fields[$count]['id']       = 'offset';
$fields[$count]['type']     = 'HIDDEN';
$fields[$count]['required'] = 0;
$fields[$count]['value']    = $multitask['offset'];

$count++;

$fields[$count]['id']       = 'import_do';
$fields[$count]['type']     = 'HIDDEN';
$fields[$count]['required'] = 0;
$fields[$count]['value']    = 1;

$count++;

$import_dbimptype = $this->CORE->globals('core_cgi.import_dbimptype');

if (!(empty($import_dbimptype))) {

     $fields[$count]['id']       = 'import_dbimptype';
     $fields[$count]['type']     = 'HIDDEN';
     $fields[$count]['required'] = 0;
     $fields[$count]['value']    = $import_dbimptype;

     $count++;

} // End of if statement.

if (!(empty($multitask['mtcomplete']))) {

     $fields[$count]['id']       = 'mtcomplete';
     $fields[$count]['type']     = 'HIDDEN';
     $fields[$count]['required'] = 0;
     $fields[$count]['value']    = 1;

     $count++;

} // End of if statement.

// +--
// | Print the form.
// +--

$this->disp_form(array('header'   => $header,
                       'fields'   => $fields,
                       'step'     => $multitask['currstep'],
                       'supform'  => 1,
                       'autosub'  => 1));

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Common Functions                                        |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: import_count_rows                                      |
// +------------------------------------------------------------------+

function import_count_rows ($table = '') {

// +--
// | This function counts the rows in a table and returns the count.
// +--

// +--
// | Return an error if we weren't passed a table to load.
// +--

if (empty($table)) {return 0;}

// +--
// | Get the count.
// +--

if ($table == 'core_users') {

     $where  = 'usergroup<>' . $this->CORE_DBX->quote('superuser') . ' AND ';
     $where .= 'usergroup<>' . $this->CORE_DBX->quote('admin') . ' AND ';
     $where .= 'usergroup<>' . $this->CORE_DBX->quote('reports');

     $count = $this->CORE_DBX->sql_count(array('table' => $table, 'where' => $where));

} else {

     $count = $this->CORE_DBX->sql_count(array('table' => $table));

} // End of if statement.

if (($this->CORE->IsError($count)) || (empty($count))) {$count = 0;}

return $count;

// +--
// | Return the count.
// +--

return $count;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_data                                       |
// +------------------------------------------------------------------+

function import_load_data ($table = '',$offset = 0,$count = 100) {

// +--
// | This function loads data from a table.  It returns a DB-like
// | array.
// +--

// +--
// | Return an error if we weren't passed a table to load or 
// | table definition information.
// +--

if (empty($table)) {return array();}

$sortfield = 'id';
$sortorder = 'ASC';

if ($table == 'ecom_orders') {$sortfield = 'epochorder'; $sortorder = 'DESC';}
if ($table == 'ecom_orderitems') {$sortfield = 'orderid'; $sortorder = 'DESC';}
if ($table == 'core_users') {$sortfield = 'lastaccess'; $sortorder = 'ASC';}

// +--
// | Load the data.
// +--

$sql  = 'SELECT * FROM ' . $table;

if ($table == 'core_users') {

     $sql .= ' WHERE usergroup<>' . $this->CORE_DBX->quote('superuser') . ' AND ';
     $sql .= 'usergroup<>' . $this->CORE_DBX->quote('admin') . ' AND ';
     $sql .= 'usergroup<>' . $this->CORE_DBX->quote('reports');

} // End of if statement.

if ($count == 'ALL') {

     $data = $this->CORE_DBX->sql_do(array('sql'    => $sql,
                                           'table'  => $table,
                                           'order'  => array($sortfield => $sortorder)));

} else {

     $data = $this->CORE_DBX->sql_do(array('sql'    => $sql,
                                           'table'  => $table,
                                           'order'  => array($sortfield => $sortorder),
                                           'count'  => $count,
                                           'offset' => $offset));

} // End of if statement.

// +--
// | Handle errors.
// +--

if ($this->CORE->IsError($data)) {return array();}

// +--
// | Return the data.
// +--

return $data;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_configphp                                  |
// +------------------------------------------------------------------+

function import_load_configphp ($configphp = '') {

// +--
// | Loads configuration files from an install to be imported from.
// +--

if ((empty($configphp)) || (!(@file_exists($configphp)))) {return false;}

// +--
// | Load public configuration.
// +--

$config = array();

@include($configphp);

if (empty($config)) {return false;}

foreach ($config as $key => $value) {

     if (preg_match('/^core\./',$key)) {

          $key = preg_replace('/^core\./','importer.import_',$key);

          $this->CORE->globals($key,$value);

     } // End of if statement.

} // End of foreach statement.

unset($config);

$testvar = $this->CORE->globals('importer.import_path_private');

if (empty($testvar)) {return false;}

// +--
// | Load private configuration.
// +--

$configphp = $testvar . '/config.php';

$config = array();

@include($configphp);

if (empty($config)) {return false;}

foreach ($config as $key => $value) {

     if (preg_match('/^core\./',$key)) {

          $key = preg_replace('/^core\./','importer.import_',$key);

          $this->CORE->globals($key,$value);

     } // End of if statement.

} // End of foreach statement.

$testvar = $this->CORE->globals('importer.import_password_copy');

if (empty($testvar)) {return false;}

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_connect_db                                      |
// +------------------------------------------------------------------+

function import_connect_db () {

// +--
// | Loads a connection as $this->CORE_DBX to the database being
// | imported from.
// +--

$dbtype   = $this->CORE->globals('importer.import_db_dbtype');
$hostname = $this->CORE->globals('importer.import_db_hostname');
$dbname   = $this->CORE->globals('importer.import_db_dbname');
$username = $this->CORE->globals('importer.import_db_username');
$password = $this->CORE->globals('importer.import_db_password');

$dsn = array('dbtype'   => $dbtype,
             'username' => $username,
             'password' => $password,
             'hostname' => $hostname,
             'dbname'   => $dbname);

// +--
// | Attempt to load CORE_DB using an alternate handle.
// +--

$this->CORE_DBX =& $this->CORE->load_object(array('app'       => 'core',
                                                  'class'     => 'CORE_DB',
                                                  'name'      => 'CORE_DB_2',
                                                  'construct' => $dsn));

// +--
// | Handle constructor errors.
// +--

if ($this->CORE->IsError($this->CORE_DBX)) {return false;}

// +--
// | Connect and handle errors.
// +--

$result = $this->CORE_DBX->connect();

if ($this->CORE->IsError($result)) {return false;}

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | End of Class                                                     |
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// | End Of File                                                      |
// +------------------------------------------------------------------+

?>